      MODULE HPF_LAPACK

      INTERFACE LA_GESV

      subroutine SLhpf_sgesv(A, B, ipiv, info)
         include 'misc.h'
         real(SP), intent(inout), dimension(:,:) :: A, B
         integer, optional, intent(out) :: ipiv(:), info
!HPF$ INHERIT A, B
!HPF$ ALIGN IPIV(:) WITH A(:,*)
      end subroutine SLhpf_sgesv

      subroutine SLhpf_sgesv_v(A, B, ipiv, info)
         include 'misc.h'
         real(SP), intent(inout), dimension(:,:) :: A
         real(SP), intent(inout), dimension(:) :: B
         integer, optional, intent(out) :: ipiv(:), info
!HPF$ INHERIT A, B
!HPF$ ALIGN IPIV(:) WITH A(:,*)
      end subroutine SLhpf_sgesv_v

      subroutine SLhpf_dgesv(A, B, ipiv, info)
         include 'misc.h'
         real(DP), intent(inout), dimension(:,:) :: A, B
         integer, optional, intent(out) :: ipiv(:), info
!HPF$ INHERIT A, B
!HPF$ ALIGN IPIV(:) WITH A(:,*)
      end subroutine SLhpf_dgesv

      subroutine SLhpf_dgesv_v(A, B, ipiv, info)
         include 'misc.h'
         real(DP), intent(inout), dimension(:,:) :: A
         real(DP), intent(inout), dimension(:) :: B
         integer, optional, intent(out) :: ipiv(:), info
!HPF$ INHERIT A, B
!HPF$ ALIGN IPIV(:) WITH A(:,*)
      end subroutine SLhpf_dgesv_v

      subroutine SLhpf_cgesv(A, B, ipiv, info)
         include 'misc.h'
         complex(SP), intent(inout), dimension(:,:) :: A, B
         integer, optional, intent(out) :: ipiv(:), info
!HPF$ INHERIT A, B
!HPF$ ALIGN IPIV(:) WITH A(:,*)
      end subroutine SLhpf_cgesv

      subroutine SLhpf_cgesv_v(A, B, ipiv, info)
         include 'misc.h'
         complex(SP), intent(inout), dimension(:,:) :: A
         complex(SP), intent(inout), dimension(:) :: B
         integer, optional, intent(out) :: ipiv(:), info
!HPF$ INHERIT A, B
!HPF$ ALIGN IPIV(:) WITH A(:,*)
      end subroutine SLhpf_cgesv_v

      subroutine SLhpf_zgesv(A, B, ipiv, info)
         include 'misc.h'
         complex(DP), intent(inout), dimension(:,:) :: A, B
         integer, optional, intent(out) :: ipiv(:), info
!HPF$ INHERIT A, B
!HPF$ ALIGN IPIV(:) WITH A(:,*)
      end subroutine SLhpf_zgesv

      subroutine SLhpf_zgesv_v(A, B, ipiv, info)
         include 'misc.h'
         complex(DP), intent(inout), dimension(:,:) :: A
         complex(DP), intent(inout), dimension(:) :: B
         integer, optional, intent(out) :: ipiv(:), info
!HPF$ INHERIT A, B
!HPF$ ALIGN IPIV(:) WITH A(:,*)
      end subroutine SLhpf_zgesv_v

      END INTERFACE

      INTERFACE LA_POSV

      subroutine SLhpf_sposv(A, B, uplo, info)
         include 'misc.h'
         real(SP), intent(inout), dimension(:,:) :: A, B
         character(LEN=1), optional, intent(in) :: uplo
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_sposv

      subroutine SLhpf_sposv_v(A, B, uplo, info)
         include 'misc.h'
         real(SP), intent(inout), dimension(:,:) :: A
         real(SP), intent(inout), dimension(:) :: B
         character(LEN=1), optional, intent(in) :: uplo
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_sposv_v

      subroutine SLhpf_dposv(A, B, uplo, info)
         include 'misc.h'
         real(DP), intent(inout), dimension(:,:) :: A, B
         character(LEN=1), optional, intent(in) :: uplo
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_dposv

      subroutine SLhpf_dposv_v(A, B, uplo, info)
         include 'misc.h'
         real(DP), intent(inout), dimension(:,:) :: A
         real(DP), intent(inout), dimension(:) :: B
         character(LEN=1), optional, intent(in) :: uplo
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_dposv_v

      subroutine SLhpf_cposv(A, B, uplo, info)
         include 'misc.h'
         complex(SP), intent(inout), dimension(:,:) :: A, B
         character(LEN=1), optional, intent(in) :: uplo
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_cposv

      subroutine SLhpf_cposv_v(A, B, uplo, info)
         include 'misc.h'
         complex(SP), intent(inout), dimension(:,:) :: A
         complex(SP), intent(inout), dimension(:) :: B
         character(LEN=1), optional, intent(in) :: uplo
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_cposv_v

      subroutine SLhpf_zposv(A, B, uplo, info)
         include 'misc.h'
         complex(DP), intent(inout), dimension(:,:) :: A, B
         character(LEN=1), optional, intent(in) :: uplo
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_zposv

      subroutine SLhpf_zposv_v(A, B, uplo, info)
         include 'misc.h'
         complex(DP), intent(inout), dimension(:,:) :: A
         complex(DP), intent(inout), dimension(:) :: B
         character(LEN=1), optional, intent(in) :: uplo
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_zposv_v

      END INTERFACE

      INTERFACE LA_GELS

      subroutine SLhpf_sgels(A, B, trans, info)
         include 'misc.h'
         real(SP), intent(inout), dimension(:,:) :: A, B
         character(LEN=1), optional, intent(in) :: trans
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_sgels

      subroutine SLhpf_sgels_v(A, B, trans, info)
         include 'misc.h'
         real(SP), intent(inout), dimension(:,:) :: A
         real(SP), intent(inout), dimension(:) :: B
         character(LEN=1), optional, intent(in) :: trans
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_sgels_v

      subroutine SLhpf_dgels(A, B, trans, info)
         include 'misc.h'
         real(DP), intent(inout), dimension(:,:) :: A, B
         character(LEN=1), optional, intent(in) :: trans
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_dgels

      subroutine SLhpf_dgels_v(A, B, trans, info)
         include 'misc.h'
         real(DP), intent(inout), dimension(:,:) :: A
         real(DP), intent(inout), dimension(:) :: B
         character(LEN=1), optional, intent(in) :: trans
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_dgels_v

      subroutine SLhpf_cgels(A, B, trans, info)
         include 'misc.h'
         complex(SP), intent(inout), dimension(:,:) :: A, B
         character(LEN=1), optional, intent(in) :: trans
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_cgels

      subroutine SLhpf_cgels_v(A, B, trans, info)
         include 'misc.h'
         complex(SP), intent(inout), dimension(:,:) :: A
         complex(SP), intent(inout), dimension(:) :: B
         character(LEN=1), optional, intent(in) :: trans
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_cgels_v

      subroutine SLhpf_zgels(A, B, trans, info)
         include 'misc.h'
         complex(DP), intent(inout), dimension(:,:) :: A, B
         character(LEN=1), optional, intent(in) :: trans
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_zgels

      subroutine SLhpf_zgels_v(A, B, trans, info)
         include 'misc.h'
         complex(DP), intent(inout), dimension(:,:) :: A
         complex(DP), intent(inout), dimension(:) :: B
         character(LEN=1), optional, intent(in) :: trans
         integer, optional, intent(out) :: info
!HPF$ INHERIT A, B
      end subroutine SLhpf_zgels_v

      END INTERFACE

      INTERFACE LA_GEMM

      subroutine SLhpf_sgemm(A, B, C, transA, transB, alpha, beta)
         include 'misc.h'
         real(SP), intent(in), dimension(:,:) :: A, B
         real(SP), intent(inout), dimension(:,:) :: C
         character(LEN=1), optional, intent(in) :: transA, transB
         real(SP), optional, intent(in) :: alpha, beta
!HPF$ INHERIT A, B, C
      end subroutine SLhpf_sgemm

      subroutine SLhpf_dgemm(A, B, C, transA, transB, alpha, beta)
         include 'misc.h'
         real(DP), intent(in), dimension(:,:) :: A, B
         real(DP), intent(inout), dimension(:,:) :: C
         character(LEN=1), optional, intent(in) :: transA, transB
         real(DP), optional, intent(in) :: alpha, beta
!HPF$ INHERIT A, B, C
      end subroutine SLhpf_dgemm

      subroutine SLhpf_cgemm(A, B, C, transA, transB, alpha, beta)
         include 'misc.h'
         complex(SP), intent(in), dimension(:,:) :: A, B
         complex(SP), intent(inout), dimension(:,:) :: C
         character(LEN=1), optional, intent(in) :: transA, transB
         complex(SP), optional, intent(in) :: alpha, beta
!HPF$ INHERIT A, B, C
      end subroutine SLhpf_cgemm

      subroutine SLhpf_zgemm(A, B, C, transA, transB, alpha, beta)
         include 'misc.h'
         complex(DP), intent(in), dimension(:,:) :: A, B
         complex(DP), intent(inout), dimension(:,:) :: C
         character(LEN=1), optional, intent(in) :: transA, transB
         complex(DP), optional, intent(in) :: alpha, beta
!HPF$ INHERIT A, B, C
      end subroutine SLhpf_zgemm

      END INTERFACE

      INTERFACE LA_TRSM
      subroutine SLhpf_strsm(A, B, side, uplo, trans, diag, alpha)
         include 'misc.h'
         real(SP), intent(in), dimension(:,:) :: A
         real(SP), intent(inout), dimension(:,:) :: B
         character(LEN=1), optional, intent(in) :: side, uplo, trans,   &
     &                                             diag
         real(SP), optional, intent(in) :: alpha
!HPF$ INHERIT A, B
      end subroutine SLhpf_strsm

      subroutine SLhpf_dtrsm(A, B, side, uplo, trans, diag, alpha)
         include 'misc.h'
         real(DP), intent(in), dimension(:,:) :: A
         real(DP), intent(inout), dimension(:,:) :: B
         character(LEN=1), optional, intent(in) :: side, uplo, trans,   &
     &                                             diag
         real(DP), optional, intent(in) :: alpha
!HPF$ INHERIT A, B
      end subroutine SLhpf_dtrsm

      subroutine SLhpf_ctrsm(A, B, side, uplo, trans, diag, alpha)
         include 'misc.h'
         complex(SP), intent(in), dimension(:,:) :: A
         complex(SP), intent(inout), dimension(:,:) :: B
         character(LEN=1), optional, intent(in) :: side, uplo, trans,   &
     &                                             diag
         complex(SP), optional, intent(in) :: alpha
!HPF$ INHERIT A, B
      end subroutine SLhpf_ctrsm

      subroutine SLhpf_ztrsm(A, B, side, uplo, trans, diag, alpha)
         include 'misc.h'
         complex(DP), intent(in), dimension(:,:) :: A
         complex(DP), intent(inout), dimension(:,:) :: B
         character(LEN=1), optional, intent(in) :: side, uplo, trans,   &
     &                                             diag
         complex(DP), optional, intent(in) :: alpha
!HPF$ INHERIT A, B
      end subroutine SLhpf_ztrsm

      END INTERFACE

      INTERFACE LA_SYEV
      subroutine SLhpf_ssyev(A, W, Z, uplo0, info0)
         implicit none
         include 'pblas.h'
         include 'misc.h'
         real(SP), intent(inout), dimension(:,:) :: A
         real(SP), intent(out), dimension(:) :: W
         real(SP), optional, intent(out), dimension(:,:) :: Z
         character(LEN=1), optional, intent(in) :: uplo0
         integer, optional, intent(out) :: info0
!HPF$ INHERIT A, Z
! the following should replicate w accross all processors
!HPF$ ALIGN W(*) WITH A(*,*)
      end subroutine SLhpf_ssyev

      subroutine SLhpf_dsyev(A, W, Z, uplo0, info0)
         implicit none
         include 'pblas.h'
         include 'misc.h'
         real(DP), intent(inout), dimension(:,:) :: A
         real(DP), intent(out), dimension(:) :: W
         real(DP), optional, intent(out), dimension(:,:) :: Z
         character(LEN=1), optional, intent(in) :: uplo0
         integer, optional, intent(out) :: info0
!HPF$ INHERIT A, Z
! the following should replicate w accross all processors
!HPF$ ALIGN W(*) WITH A(*,*)
      end subroutine SLhpf_dsyev

      subroutine SLhpf_csyev(A, W, Z, uplo0, info0)
         implicit none
         include 'pblas.h'
         include 'misc.h'
         complex(SP), intent(inout), dimension(:,:) :: A
         complex(SP), intent(out), dimension(:) :: W
         complex(SP), optional, intent(out), dimension(:,:) :: Z
         character(LEN=1), optional, intent(in) :: uplo0
         integer, optional, intent(out) :: info0
!HPF$ INHERIT A, Z
! the following should replicate w accross all processors
!HPF$ ALIGN W(*) WITH A(*,*)
      end subroutine SLhpf_csyev

      subroutine SLhpf_zsyev(A, W, Z, uplo0, info0)
         implicit none
         include 'pblas.h'
         include 'misc.h'
         complex(DP), intent(inout), dimension(:,:) :: A
         complex(DP), intent(out), dimension(:) :: W
         complex(DP), optional, intent(out), dimension(:,:) :: Z
         character(LEN=1), optional, intent(in) :: uplo0
         integer, optional, intent(out) :: info0
!HPF$ INHERIT A, Z
! the following should replicate w accross all processors
!HPF$ ALIGN W(*) WITH A(*,*)
      end subroutine SLhpf_zsyev

      END INTERFACE

      INTERFACE

      extrinsic(hpf_local) subroutine SLhpf_timer_boot()
      end subroutine SLhpf_timer_boot

      extrinsic(hpf_local) subroutine SLhpf_timer(I)
         integer, intent(in) :: I
      end subroutine SLhpf_timer

      extrinsic(hpf_local) function SLhpf_timer_inquire(TimeType, I)
         include 'misc.h'
         include 'pblas.h'
         real(DP), dimension(NUMBER_OF_PROCESSORS()) ::                 &
     &             SLhpf_timer_inquire
!HPF$ DISTRIBUTE(block) :: SLhpf_timer_inquire
         character*1, intent(in) :: TimeType
         integer, intent(in) :: I
      end function SLhpf_timer_inquire

      END INTERFACE
      END MODULE HPF_LAPACK
