      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_cgels1(trans, m, n, nrhs, A, ia, ja, descA, B,   &
     &                        ib, jb, descB, info)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     University of Tennessee, Knoxville
!     Code contributors: L. Susan Blackford
!     Last modified by: C. A. Papadopoulos
!
      include 'pblas.h'
      include 'misc.h'
      character(LEN=1), intent(in) :: trans
      integer, intent(in) :: m, n, nrhs, ia, ja, ib, jb
      integer, dimension(:,:), intent(inout) :: descA, descB
      integer, intent(out) :: info
      complex(SP), intent(inout), dimension(:,:) :: A, B
!HPF$ INHERIT A, B
!HPF$ DISTRIBUTE(*,block) :: descA, descB

      integer :: ictxt, nprow, npcol, myrow, mycol, i, lwork
      complex(SP) :: work1(1)
      complex(SP), allocatable :: work(:)

      INTERFACE
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridinfo( icontxt, nprow, npcol, myprow, mypcol )
         integer, intent(in) :: icontxt
         integer, intent(out) :: nprow, npcol, myprow, mypcol
      end subroutine blacs_gridinfo
      extrinsic(    f77_local    ) subroutine                           &
     &pcgels(trans, m, n, nrhs, A, ia, ja, descA, B, ib, jb, descB,     &
     &       work, lwork, info)
        include 'pblas.h'
        include 'misc.h'
        character(LEN=1), intent(in) :: trans
        integer, intent(in) :: m, n, nrhs, ia, ja, ib, jb, lwork
!       Write-around for pghpf bug
!        integer, intent(inout), dimension(*) :: descA, descB
        integer, intent(inout), dimension(DLEN_,1) :: descA, descB
        integer, intent(out) :: info
        complex(SP), intent(inout), dimension(descA(LLD_),*) :: A
        complex(SP), intent(inout), dimension(descB(LLD_),*) :: B
        complex(SP), intent(out), dimension(*) :: work
      end subroutine pcgels
      extrinsic(hpf_local)                                              &
     &integer function SLhpf_cget_lld(A, descA)
         include 'misc.h'
         include 'pblas.h'
         complex(SP), intent(in), dimension(:,:) :: A
         integer, intent(in), dimension(:,:) :: DESCA
!HPF$    DISTRIBUTE(*,block) :: descA
      end function SLhpf_cget_lld
      END INTERFACE

      ictxt = descA(CTXT_,1)
      call blacs_gridinfo(ictxt, nprow, npcol, myrow, mycol)
      if (myrow .ne. -1) then
         descA(LLD_,1)  = SLhpf_cget_lld(A, descA)
         descB(LLD_,1)  = SLhpf_cget_lld(B, descB)
!
! query for workspace
!
         call pcgels(trans, m, n, nrhs, A, ia, ja, descA, b, ib, jb,    &
     &               descB, work1, -1, info)
         lwork = work1(1)
         allocate( work(lwork) )
         call pcgels(trans, m, n, nrhs, A, ia, ja, descA, b, ib, jb,    &
     &               descB, work, lwork, info)
         deallocate( work )
      end if

      return
      end

