      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_cgesv1_v(n, nrhs, A, ia, ja, descA, B,             &
     &                        ib, jb, descB, info, ipiv)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by C.A. Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      include 'pblas.h'
      include 'misc.h'
      integer, intent(in) :: n, nrhs, ia, ja, ib, jb
      integer, dimension(:,:), intent(inout) :: descA, descB
      integer, optional, intent(out) :: IPIV(:)
      integer, intent(out) :: info
      complex(SP), intent(inout), dimension(:,:) :: A
      complex(SP), intent(inout), dimension(:) :: B
!HPF$ INHERIT A, B, IPIV
!HPF$ DISTRIBUTE(*,block) :: descA, descB

      integer :: ictxt, nprow, npcol, myrow, mycol, i
      integer, allocatable :: ipiv2(:)

      INTERFACE
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridinfo( icontxt, nprow, npcol, myprow, mypcol )
         integer, intent(in) :: icontxt
         integer, intent(out) :: nprow, npcol, myprow, mypcol
      end subroutine blacs_gridinfo
      extrinsic(hpf_local)                                              &
     &integer function SLhpf_cget_lld(A, descA)
         include 'misc.h'
         include 'pblas.h'
         complex(SP), intent(in), dimension(:,:) :: A
         integer, intent(in), dimension(:,:) :: DESCA
!HPF$    DISTRIBUTE(*,block) :: descA
      end function SLhpf_cget_lld
      extrinsic(hpf_local)                                              &
     &integer function SLhpf_cget_lld_v(A, descA)
         include 'misc.h'
         include 'pblas.h'
         complex(SP), intent(in), dimension(:) :: A
         integer, intent(in), dimension(:,:) :: DESCA
!HPF$    DISTRIBUTE(*,block) :: descA
      end function SLhpf_cget_lld_v
      extrinsic(    f77_local    ) subroutine                           &
     &pcgesv( n, nrhs, a, ia, ja, desca, ipiv, b, ib, jb, descb, info )
        include 'pblas.h'
        include 'misc.h'
        integer, intent(in) :: n, nrhs, ia, ja, ib, jb
!       Write-around for pghpf bug
!        integer, intent(in), dimension(*) :: descA, descB
        integer, intent(in), dimension(DLEN_,1) :: descA, descB
!       Write-around for pghpf bug
!       complex(SP), intent(inout) :: A(descA(LLD_),*), B(descB(LLD_))
        complex(SP), intent(inout) :: A(descA(LLD_),*), B(*)
        integer, intent(out) :: ipiv(*), info
      end subroutine pcgesv
      END INTERFACE

      ictxt = descA(CTXT_,1)
      call blacs_gridinfo(ictxt, nprow, npcol, myrow, mycol)
      if (myrow .ne. -1) then
         descA(LLD_,1)  = SLhpf_cget_lld(A, descA)
         descB(LLD_,1)  = SLhpf_cget_lld_v(B, descB)

         allocate( ipiv2(size(A,1) + descA(MB_,1)) )
         call pcgesv(n, nrhs, A, ia, ja, descA, ipiv2, b, ib, jb, descB, &
     &               info)

         if ( present(ipiv) ) then
            forall(i=1:size(A,1)) ipiv(i) = ipiv2(i)
         end if
         deallocate(ipiv2)
      end if

      return
      end
