      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_compare_grids(P1, Q1, pmap1, desc1, P2, Q2,      &
     &                               pmap2, desc2, info)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     University of Tennessee, Knoxville
!     Code contributors: R. Clint Whaley
!     Last modified by: C. A. Papadopoulos
!
      include 'pblas.h'
!
!     INFO = 0 : No Error, pmap2 (sub)grid of pmap1
!     INFO = 1 : No Error, pmap1 (sub)grid of pmap2
!     INFO < 0 : Error: grids do not match
!
      integer, intent(inout) :: P1, Q1, P2, Q2
      integer, intent(inout), dimension(:) :: pmap1, pmap2
      integer, intent(inout), dimension(:,:) :: desc1, desc2
      integer, intent(out) :: info
!HPF$ DISTRIBUTE(*,block) :: desc1, desc2
!HPF$ INHERIT pmap1, pmap2

      integer :: mP1, mQ1, mP2, mQ2, rs1, cs1, rs2, cs2, Np
      integer :: i, j, k

!
!     See if pmap2 is a subgrid of pmap1
!
      info = 0
      mP2 = min(P2, (desc2(M_,1)+desc2(MB_,1))/desc2(MB_,1))
      mQ2 = min(Q2, (desc2(N_,1)+desc2(NB_,1))/desc2(NB_,1))
      if (P1.ge.mP2 .and. Q1.ge.mQ2 ) then
         rs2 = desc2(RSRC_,1)
         cs2 = desc2(CSRC_,1)
         Np = P1*Q1
         k = pmap2(rs2+cs2*P2+1)
         do i = 1, Np
            if (pmap1(i) .eq. k) exit
         end do
         if (pmap1(i) .eq. k) then
            rs1 = MOD(i-1,P1)
            cs1 = (i-1)/P1
            grid1 : do j = 0, mQ2-1
               do i = 0, mP2-1
                  if (pmap1(MOD(rs1+i,P1)+MOD(cs1+j,Q1)*P1+1) .ne.      &
     &                pmap2(MOD(rs2+i,P2)+MOD(cs2+j,Q2)*P2+1) ) then
                     info = -1
                     exit grid1
                  end if
               end do
            end do grid1
            if (info .eq. 0) then
               pmap2(1:Np) = pmap1(1:Np)
               P2 = P1
               Q2 = Q1
               desc2(CTXT_,1) = desc1(CTXT_,1)
               desc2(RSRC_,1) = rs1
               desc2(CSRC_,1) = cs1
               return
            end if
            info = 0
         end if
      end if
!
!     Otherwise, see if pmap1 is a subgrid of pmap2
!
      mP1 = min(P1, (desc1(M_,1)+desc1(MB_,1))/desc1(MB_,1))
      mQ1 = min(Q1, (desc1(N_,1)+desc1(NB_,1))/desc1(NB_,1))
      if (P2.ge.mP1 .and. Q2.ge.mQ1) then
         rs1 = desc1(RSRC_,1)
         cs1 = desc1(CSRC_,1)
         Np = P2 * Q2
         k = pmap1(rs1+cs1*P1+1)
         do i = 1, Np
            if (pmap2(i) .eq. k) exit
         end do
         if (pmap2(i) .eq. k) then
            rs2 = MOD(i-1, P2)
            cs2 = (i-1) / P2
            grid2 : do j = 0, mQ1-1
               do i = 0, mP1-1
                  if (pmap1(MOD(rs1+i,P1)+MOD(cs1+j,Q1)*P1+1) .ne.      &
     &                pmap2(MOD(rs2+i,P2)+MOD(cs2+j,Q2)*P2+1) ) then
                     info = -2
                     exit grid2
                  end if
               end do
            end do grid2
            if (info .eq. 0) then
               pmap1(1:Np) = pmap2(1:Np)
               P1 = P2
               Q1 = Q2
               desc1(CTXT_,1) = desc2(CTXT_,1)
               desc1(RSRC_,1) = rs2
               desc1(CSRC_,1) = cs2
               info = 1
            else
               info = -3
            end if
         else
            info = -4
         end if
      else
         info = -5
      end if

      return
      end
