      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_dgels2_v(P, Q, mbA, nbA, mbB, nbB,                 &
     &                          trans, m, n, nrhs, A, ia, ja, descA,    &
     &                          B, ib, jb, descB, info)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by C. A. Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by L. Susan Blackford,
!     and R. Clint Whaley
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      include 'pblas.h'
      include 'misc.h'
      character(LEN=1), intent(in) :: trans
      integer, intent(in) :: P, Q, mbA, nbA, mbB, nbB, m, n, nrhs,      &
     &                       ia, ja, ib, jb
      integer, dimension(:,:), intent(inout) :: descA, descB
      integer, intent(out) :: info
      real(DP), intent(inout), dimension(:,:) :: A
      real(DP), intent(inout), dimension(:) :: B
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ DISTRIBUTE A(CYCLIC(mbA), CYCLIC(nbA)) ONTO PROC
! due to pghpf bug need to align with first column
! instead of last
! !HPF$ ALIGN B(I) with A(I,n)
!HPF$ ALIGN B(I) with A(I,1)
!HPF$ DISTRIBUTE(*,block) :: descA, descB


      integer :: ictxt, nprow, npcol, myrow, mycol, itmp(2), P2, Q2, i, &
     &           lwork
      real(DP) :: work1(1)
      real(DP), allocatable :: work(:)
      integer, dimension(NUMBER_OF_PROCESSORS()) :: pmap

      INTERFACE
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_get( icontxt, what, val )
         integer, intent(in) :: icontxt, what
         integer, intent(out) :: val(*)
      end subroutine blacs_get
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridmap( icontxt, umap, ldu, nprow, npcol )
         integer, intent(inout) :: icontxt
         integer, intent(in) :: ldu, nprow, npcol
         integer, intent(in) :: umap(ldu,*)
      end subroutine blacs_gridmap
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridinfo( icontxt, nprow, npcol, myprow, mypcol )
         integer, intent(in) :: icontxt
         integer, intent(out) :: nprow, npcol, myprow, mypcol
      end subroutine blacs_gridinfo
      extrinsic(hpf_local)                                              &
     &integer function SLhpf_dget_lld(A, descA)
         include 'misc.h'
         include 'pblas.h'
         real(DP), intent(in), dimension(:,:) :: A
         integer, intent(in), dimension(:,:) :: DESCA
!HPF$    DISTRIBUTE(*,block) :: descA
      end function SLhpf_dget_lld
      extrinsic(hpf_local)                                              &
     &integer function SLhpf_dget_lld_v(A, descA)
         include 'misc.h'
         include 'pblas.h'
         real(DP), intent(in), dimension(:) :: A
         integer, intent(in), dimension(:,:) :: DESCA
!HPF$    DISTRIBUTE(*,block) :: descA
      end function SLhpf_dget_lld_v
      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_dget_procmap(A, desca, P, Q, pmap)
         include 'misc.h'
         real(DP), intent(in) :: A(:,:)
         integer, intent(inout) :: descA(:,:)
         integer, intent(out) :: P, Q, pmap(:)
!HPF$    DISTRIBUTE(*,block) :: descA
!HPF$    INHERIT A, pmap
      end subroutine SLhpf_dget_procmap
      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_compare_grids(P1, Q1, pmap1, desc1, P2, Q2,      &
     &                               pmap2, desc2, info)
         integer, intent(inout) :: P1, Q1, P2, Q2
         integer, intent(inout), dimension(:) :: pmap1, pmap2
         integer, intent(inout) :: desc1(:,:), desc2(:,:)
         integer, intent(out) :: info
!HPF$    DISTRIBUTE(*,block) :: desc1, desc2
!HPF$    INHERIT pmap1, pmap2
      end subroutine SLhpf_compare_grids
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridexit( icontxt )
         integer, intent(in) :: icontxt
      end subroutine blacs_gridexit
      extrinsic(    f77_local    ) subroutine                           &
     &pdgels(trans, m, n, nrhs, A, ia, ja, descA, B, ib, jb, descB,     &
     &       work, lwork, info)
        include 'pblas.h'
        include 'misc.h'
        character(LEN=1), intent(in) :: trans
        integer, intent(in) :: m, n, nrhs, ia, ja, ib, jb, lwork
!       Write-around for pghpf bug
!        integer, intent(inout), dimension(*) :: descA, descB
        integer, intent(inout), dimension(DLEN_,1) :: descA, descB
        integer, intent(out) :: info
        real(DP), intent(inout), dimension(descA(LLD_),*) :: A
!       Write-around for pghpf bug
!        real(DP), intent(inout), dimension(descB(LLD_)) :: B
        real(DP), intent(inout), dimension(*) :: B
        real(DP), intent(out), dimension(*) :: work
      end subroutine pdgels
      END INTERFACE

      call SLhpf_dget_procmap(A, descA, nprow, npcol, pmap)
      call blacs_get(-1, 0, itmp)
      ictxt = itmp(1)
      call blacs_gridmap(ictxt, pmap, nprow, nprow, npcol)
      call blacs_gridinfo(ictxt, nprow, npcol, myrow, mycol)
      if (myrow .ne. -1) then
         descA(RSRC_,1) = 0
         descA(CSRC_,1) = 0
         descA(CTXT_,1) = ictxt
         descA(LLD_,1)  = SLhpf_dget_lld(A, descA)
         descB(RSRC_,1) = 0
         descB(CSRC_,1) = 0
         descB(CTXT_,1) = ictxt
         descB(LLD_,1)  = SLhpf_dget_lld_v(B, descB)
!
! query for workspace
!
         call pdgels(trans, m, n, nrhs, A, ia, ja, descA, b, ib, jb,    &
     &               descB, work1, -1, info)
         lwork = work1(1)
         allocate( work(lwork) )
         call pdgels(trans, m, n, nrhs, A, ia, ja, descA, b, ib, jb,    &
     &               descB, work, lwork, info)
         deallocate( work )

         call blacs_gridexit(ictxt)
      end if

      return
      end
