      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_dsyev2(P, Q, jobz, uplo, n, A, ia, ja,descA,     &
     &                        W, Z, iz, jz, descZ, info, mbA, nbA,      &
     &                        mbZ, nbZ)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by Caroline A. Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      include 'pblas.h'
      include 'misc.h'
      character(LEN=1), intent(in) :: jobz, uplo
      integer, intent(in) :: P, Q, n, ia, ja, iz, jz, mbA,              &
     &                       nbA, mbZ, nbZ
      integer, dimension(:,:), intent(inout) :: descA, descZ
      integer, intent(out) :: info
      real(DP), intent(inout), dimension(:,:) :: A
      real(DP), optional, intent(out), dimension(:,:) :: Z
      real(DP), intent(out), dimension(:) :: W
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ DISTRIBUTE A(CYCLIC(mbA), CYCLIC(nbA)) ONTO PROC
!HPF$ DISTRIBUTE Z(CYCLIC(mbZ), CYCLIC(nbZ)) ONTO PROC
!HPF$ ALIGN W(*)  WITH A(*,*)
!HPF$ DISTRIBUTE(*,block) :: descA, descZ

      integer :: ictxt, nprow, npcol, myrow, mycol, itmp(2), P2, Q2, i
      integer :: lwork
      real(DP) :: Z1(1,1), work1(1)
      real(DP), allocatable :: work(:)
      integer, dimension(NUMBER_OF_PROCESSORS()) :: pmap

      INTERFACE
      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_dget_procmap(A, desca, P, Q, pmap)
         include 'misc.h'
         real(DP), intent(in) :: A(:,:)
         integer, intent(inout) :: descA(:,:)
         integer, intent(out) :: P, Q, pmap(:)
!HPF$    DISTRIBUTE(*,block) :: descA
!HPF$    INHERIT A, pmap
      end subroutine SLhpf_dget_procmap
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_get( icontxt, what, val )
         integer, intent(in) :: icontxt, what
         integer, intent(out) :: val(*)
      end subroutine blacs_get
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridmap( icontxt, umap, ldu, nprow, npcol )
         integer, intent(inout) :: icontxt
         integer, intent(in) :: ldu, nprow, npcol
         integer, intent(in) :: umap(ldu,*)
      end subroutine blacs_gridmap
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridinfo( icontxt, nprow, npcol, myprow, mypcol )
         integer, intent(in) :: icontxt
         integer, intent(out) :: nprow, npcol, myprow, mypcol
      end subroutine blacs_gridinfo
      extrinsic(hpf_local)                                              &
     &integer function SLhpf_dget_lld(A, descA)
         include 'misc.h'
         include 'pblas.h'
         real(DP), intent(in), dimension(:,:) :: A
         integer, intent(in), dimension(:,:) :: DESCA
!HPF$    DISTRIBUTE(*,block) :: descA
      end function SLhpf_dget_lld
      extrinsic(    f77_local    ) subroutine                           &
     &pdsyev( jobz, uplo, n, A, ia, ja, descA, W, Z, iz, jz, descZ,        &
     &             work, lwork, info )
        include 'pblas.h'
        include 'misc.h'
        character(LEN=1), intent(in) :: jobz, uplo
        integer, intent(in) :: n, ia, ja, iz, jz, lwork
!       Write-around for pghpf bug
!        integer, intent(in), dimension(*) :: descA, descZ
        integer, intent(in), dimension(DLEN_,1) :: descA, descZ
        real(DP), intent(inout) :: A(descA(LLD_,1),*)
        real(DP), intent(out) :: W(*), Z(descZ(LLD_,1),*), work(*)
        integer, intent(out) :: info
      end subroutine pdsyev
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridexit( icontxt )
         integer, intent(in) :: icontxt
      end subroutine blacs_gridexit
      END INTERFACE

      call SLhpf_dget_procmap(A, descA, nprow, npcol, pmap)
      call blacs_get(-1, 0, itmp)
      ictxt = itmp(1)
      call blacs_gridmap(ictxt, pmap, nprow, nprow, npcol)
      call blacs_gridinfo(ictxt, nprow, npcol, myrow, mycol)
      if (myrow .ne. -1) then
         descA(RSRC_,1) = 0
         descA(CSRC_,1) = 0
         descA(CTXT_,1) = ictxt
         descA(LLD_,1)  = SLhpf_dget_lld(A, descA)
         descZ(RSRC_,1) = 0
         descZ(CSRC_,1) = 0
         descZ(CTXT_,1) = ictxt
         if (present(Z)) then
            descZ(LLD_,1)  = SLhpf_dget_lld(Z, descZ)
            call pdsyev(jobz, uplo, n, A, ia, ja, descA, W, Z, iz, jz,       &
     &               descZ, work1, -1, info)
            lwork = work1(1)
            allocate(work(lwork))
            call pdsyev(jobz, uplo, n, A, ia, ja, descA, W, Z, iz, jz,       &
     &               descZ, work, lwork, info)
         else
            descZ(LLD_,1)  = SLhpf_dget_lld(Z, descZ)
            call pdsyev(jobz, uplo, n, A, ia, ja, descA, W, Z1, iz, jz,       &
     &               descZ, work1, -1, info)
            lwork = work1(1)
            allocate(work(lwork))
            call pdsyev(jobz, uplo, n, A, ia, ja, descA, W, Z1, iz, jz,       &
     &               descZ, work, lwork, info)
         endif

         call blacs_gridexit(ictxt)
      end if

      return
      end
