      extrinsic(hpf_local)                                              &
     &function SLhpf_get_context(P, Q, pmap, info)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      include 'pblas.h'
      integer, dimension(1) :: SLhpf_get_context
      integer, intent(inout) :: P, Q
      integer, intent(in) ::  pmap(:)
      integer, optional, intent(out) :: info
!HPF$ DISTRIBUTE SLhpf_get_context(block)
!HPF$ INHERIT pmap

      integer :: cP, cQ, cctxt, rs, cs, i, j
      integer :: itmp(2)
      data cP /-2/
      save cP, cQ, cctxt
      INTERFACE
      extrinsic(    f77_local    ) function                             &
     &blacs_pnum( icontxt, prow, pcol )
         integer :: blacs_pnum
         integer, intent(in) :: icontxt, prow, pcol
      end function blacs_pnum
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_get( icontxt, what, val )
         integer, intent(in) :: icontxt, what
         integer, intent(out) :: val(*)
      end subroutine blacs_get
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridmap( icontxt, umap, ldu, nprow, npcol )
         integer, intent(inout) :: icontxt
         integer, intent(in) :: ldu, nprow, npcol
         integer, intent(in) :: umap(ldu,*)
      end subroutine blacs_gridmap
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridexit( icontxt )
         integer, intent(in) :: icontxt
      end subroutine blacs_gridexit
      END INTERFACE
!
!     If we have a context cached, see if we can reuse it
!
      if (present(info)) info = 0
      if (cP .ne. -2) then
         if (cP.eq.P .and. cQ.eq.Q) then
            j = blacs_pnum(cctxt, 0, 0)
            do i = 1, P*Q
               if (pmap(i) .eq. j) exit
            end do
            if (pmap(i) .eq. j) then
               if (present(info)) then
                  if (i.ne.1) info = 1  ! signal caller to change {RSRC,CSRC}
               end if
               rs = mod(i-1,P)
               cs = (i-1) / P
               do j = 0, Q-1
                  do i = 0, P-1
                     if ( pmap(1+MOD(rs+i,P)+MOD(cs+j,Q)*P) .ne.        &
     &                    blacs_pnum(cctxt, i, j) ) goto 10
                  end do
               end do
               SLhpf_get_context(1) = cctxt
               return
            end if
         end if
      end if
   10 continue
      if (present(info)) info = 0
      if (cP .gt. 0) call blacs_gridexit(cctxt)
      call blacs_get(-1, 0, itmp)
      call blacs_gridmap(itmp(1), pmap, P, P, Q)
      cctxt = itmp(1)
      cP = P
      cQ = Q
      SLhpf_get_context(1) = cctxt

      return
      end
