      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_reset_src(P, Q, pmap, desc1, desc2, desc3)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      include 'pblas.h'
      integer, intent(in) :: P, Q
      integer, intent(in), dimension(:) :: pmap
      integer, intent(inout) :: desc1(:,:)
      integer, optional, intent(inout) :: desc2(:,:), desc3(:,:)
!HPF$ DISTRIBUTE(*,block) :: desc1, desc2, desc3
      INTERFACE
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridinfo( icontxt, nprow, npcol, myprow, mypcol )
         integer, intent(in) :: icontxt
         integer, intent(out) :: nprow, npcol, myprow, mypcol
      end subroutine blacs_gridinfo
      extrinsic(    f77_local    ) function                             &
     &blacs_pnum( icontxt, prow, pcol )
         integer :: blacs_pnum
         integer, intent(in) :: icontxt, prow, pcol
      end function blacs_pnum
      END INTERFACE

      integer :: ctxt, nprow, npcol, i, j
      ctxt = desc1(CTXT_,1)
      call blacs_gridinfo(ctxt, nprow, npcol, i, j)
      j = blacs_pnum(ctxt, 0, 0)
      do i = 1, P*Q
         if (pmap(i) .eq. j) exit
      end do
      if (pmap(i) .eq. j) then
         j = (i - 1) / P
         i = MOD(i-1,P)
         desc1(RSRC_,1) = MOD(desc1(RSRC_,1)+i,NPROW)
         desc1(CSRC_,1) = MOD(desc1(CSRC_,1)+i,NPCOL)
         if ( present(desc2) ) then
            desc2(RSRC_,1) = MOD(desc2(RSRC_,1)+i,NPROW)
            desc2(CSRC_,1) = MOD(desc2(CSRC_,1)+i,NPCOL)
            if ( present(desc3) ) then
               desc3(RSRC_,1) = MOD(desc3(RSRC_,1)+i,NPROW)
               desc3(CSRC_,1) = MOD(desc3(CSRC_,1)+i,NPCOL)
            end if
         end if
      else
         print*,'GRIDS ARE NOT CONFORMANT IN SLhpf_reset_src'
         call SLhpf_abort(-1)
      end if

      return
      end
