      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_sgemm1(transA, transB, m, n, k, alpha, A,        &
     &                        ia, ja, descA, B, ib, jb, descB, beta,    &
     &                        C, ic, jc, descC)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     University of Tennessee, Knoxville
!     Code contributors: R. Clint Whaley
!     Last modified by: C. A. Papadopoulos
!
      include 'pblas.h'
      include 'misc.h'
      character(LEN=1), intent(in) :: transA, transB
      integer, intent(in) :: m, n, k, ia, ja, ib, jb, ic, jc
      integer, dimension(:,:), intent(inout) :: descA, descB, descC
      real(SP), intent(in) :: alpha, beta
      real(SP), intent(in), dimension(:,:) :: A, B
      real(SP), intent(inout), dimension(:,:) :: C
!HPF$ INHERIT A, B, C
!HPF$ DISTRIBUTE(*,block) :: descA, descB, descC

      integer :: ictxt, nprow, npcol, myrow, mycol, i

      INTERFACE
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridinfo( icontxt, nprow, npcol, myprow, mypcol )
         integer, intent(in) :: icontxt
         integer, intent(out) :: nprow, npcol, myprow, mypcol
      end subroutine blacs_gridinfo
      extrinsic(    f77_local    ) subroutine                           &
     &psgemm(transa, transb, m, n, k, alpha, a, ia, ja, desca, b,       &
     &       ib, jb, descb, beta, c, ic, jc, descc)
        include 'pblas.h'
        include 'misc.h'
        character(LEN=1), intent(in) :: transA, transB
        integer, intent(in) :: m, n, k, ia, ja, ib, jb, ic, jc
!       Write-around for pghpf bug
!        integer, intent(inout), dimension(*) :: descA, descB, descC
        integer, intent(inout), dimension(DLEN_,1) :: descA, descB,     &
     &                                                descC
        real(SP), intent(in) :: alpha, beta
        real(SP), intent(in), dimension(descA(LLD_),*) :: A
        real(SP), intent(in), dimension(descB(LLD_),*) :: B
        real(SP), intent(inout), dimension(descC(LLD_),*) :: C
      end subroutine psgemm
      extrinsic(hpf_local)                                              &
     &integer function SLhpf_sget_lld(A, descA)
         include 'misc.h'
         include 'pblas.h'
         real(SP), intent(in), dimension(:,:) :: A
         integer, intent(in), dimension(:,:) :: DESCA
!HPF$    DISTRIBUTE(*,block) :: descA
      end function SLhpf_sget_lld
      END INTERFACE

      ictxt = descA(CTXT_,1)
      call blacs_gridinfo(ictxt, nprow, npcol, myrow, mycol)
      if (myrow .ne. -1) then
         descA(LLD_,1)  = SLhpf_sget_lld(A, descA)
         descB(LLD_,1)  = SLhpf_sget_lld(B, descB)
         descC(LLD_,1)  = SLhpf_sget_lld(C, descC)

         call psgemm(transA, transB, m, n, k, alpha, A, ia, ja, descA,  &
     &               B, ib, jb, descB, beta, C, ic, jc, descC)
      end if

      return
      end
