      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_sgesv2_v(P, Q, mbA, nbA, mbB, nbB,                 &
     &                        n, nrhs, A, ia, ja, descA,                &
     &                        B, ib, jb, descB, info, ipiv)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by C.A. Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      include 'pblas.h'
      include 'misc.h'
      integer, intent(in) :: P, Q, mbA, nbA, mbB, nbB, n, nrhs, ia, ja, &
     &                       ib, jb
      integer, dimension(:,:), intent(inout) :: descA, descB
      integer, optional, intent(out) :: IPIV(:)
      integer, intent(out) :: info
      real(SP), intent(inout), dimension(:,:) :: A
      real(SP), intent(inout), dimension(:) :: B
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ DISTRIBUTE A(CYCLIC(mbA), CYCLIC(nbA)) ONTO PROC
! due to pghpf bug need to align with first column
! instead of last
! !HPF$ ALIGN B(I) with A(I,n)
!HPF$ ALIGN B(I) with A(I,1)
!HPF$ ALIGN IPIV(:)  WITH A(:,*)
!HPF$ DISTRIBUTE(*,block) :: descA, descB

      integer :: ictxt, nprow, npcol, myrow, mycol, itmp(2), P2, Q2, i
      integer, dimension(NUMBER_OF_PROCESSORS()) :: pmap
      integer, allocatable, dimension(:) :: ipiv2

      INTERFACE
      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_sget_procmap(A, desca, P, Q, pmap)
         include 'misc.h'
         real(SP), intent(in) :: A(:,:)
         integer, intent(inout) :: descA(:,:)
         integer, intent(out) :: P, Q, pmap(:)
!HPF$    DISTRIBUTE(*,block) :: descA
!HPF$    INHERIT A, pmap
      end subroutine SLhpf_sget_procmap
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_get( icontxt, what, val )
         integer, intent(in) :: icontxt, what
         integer, intent(out) :: val(*)
      end subroutine blacs_get
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridmap( icontxt, umap, ldu, nprow, npcol )
         integer, intent(inout) :: icontxt
         integer, intent(in) :: ldu, nprow, npcol
         integer, intent(in) :: umap(ldu,*)
      end subroutine blacs_gridmap
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridinfo( icontxt, nprow, npcol, myprow, mypcol )
         integer, intent(in) :: icontxt
         integer, intent(out) :: nprow, npcol, myprow, mypcol
      end subroutine blacs_gridinfo
      extrinsic(hpf_local)                                              &
     &integer function SLhpf_sget_lld(A, descA)
         include 'misc.h'
         include 'pblas.h'
         real(SP), intent(in), dimension(:,:) :: A
         integer, intent(in), dimension(:,:) :: DESCA
!HPF$    DISTRIBUTE(*,block) :: descA
      end function SLhpf_sget_lld
      extrinsic(hpf_local)                                              &
     &integer function SLhpf_sget_lld_v(A, descA)
         include 'misc.h'
         include 'pblas.h'
         real(SP), intent(in), dimension(:) :: A
         integer, intent(in), dimension(:,:) :: DESCA
!HPF$    DISTRIBUTE(*,block) :: descA
      end function SLhpf_sget_lld_v
      extrinsic(    f77_local    ) subroutine                           &
     &psgesv( n, nrhs, a, ia, ja, desca, ipiv, b, ib, jb, descb, info )
        include 'pblas.h'
        include 'misc.h'
        integer, intent(in) :: n, nrhs, ia, ja, ib, jb
!       Write-around for pghpf bug
!        integer, intent(in), dimension(*) :: descA, descB
        integer, intent(in), dimension(DLEN_,1) :: descA, descB
!       Write-around for pghpf bug
!       real(SP), intent(inout) :: A(descA(LLD_),*), B(descB(LLD_))
        real(SP), intent(inout) :: A(descA(LLD_),*), B(*)
        integer, intent(out) :: ipiv(*), info
      end subroutine psgesv
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridexit( icontxt )
         integer, intent(in) :: icontxt
      end subroutine blacs_gridexit
      END INTERFACE

      call SLhpf_sget_procmap(A, descA, nprow, npcol, pmap)
      call blacs_get(-1, 0, itmp)
      ictxt = itmp(1)
      call blacs_gridmap(ictxt, pmap, nprow, nprow, npcol)
      call blacs_gridinfo(ictxt, nprow, npcol, myrow, mycol)
      if (myrow .ne. -1) then
         descA(RSRC_,1) = 0
         descA(CSRC_,1) = 0
         descA(CTXT_,1) = ictxt
         descA(LLD_,1)  = SLhpf_sget_lld(A, descA)
         descB(RSRC_,1) = 0
         descB(CSRC_,1) = 0
         descB(CTXT_,1) = ictxt
         descB(LLD_,1)  = SLhpf_sget_lld_v(B, descB)

         allocate( ipiv2(size(A,1) + descA(MB_,1)) )
         call psgesv(n, nrhs, A, ia, ja, descA, ipiv2, b, ib, jb,       &
     &               descB, info)

         if ( present(ipiv) ) then
            forall(i=1:size(A,1)) ipiv(i) = ipiv2(i)
         end if
         deallocate(ipiv2)
         call blacs_gridexit(ictxt)
      end if

      return
      end
