      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_ssyev1(jobz, uplo, n, A, ia, ja, descA, W,       &
     &                        Z, iz, jz, descZ, info)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by Caroline A. Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      implicit none
      include 'pblas.h'
      include 'misc.h'

      character(LEN=1), intent(in) :: jobz, uplo
      integer, intent(in) :: n, ia, ja, iz, jz
      integer, intent(inout), dimension(:,:) :: descA, descZ
      integer, intent(out) :: info
      real(SP), intent(inout), dimension(:,:) :: A
      real(SP), optional, intent(out), dimension(:,:) :: Z
      real(SP), intent(out), dimension(:) :: W
!HPF$ INHERIT A, Z
!HPF$ ALIGN W(*) with A(*,*)
!HPF$ DISTRIBUTE(*,block) :: descA, descZ

      integer :: ictxt, nprow, npcol, myrow, mycol, i, lwork
      real(SP) :: Z1(1,1), work1(1)
      real(SP), allocatable :: work(:)

      INTERFACE
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridinfo( icontxt, nprow, npcol, myprow, mypcol )
         integer, intent(in) :: icontxt
         integer, intent(out) :: nprow, npcol, myprow, mypcol
      end subroutine blacs_gridinfo
      extrinsic(hpf_local)                                              &
     &integer function SLhpf_sget_lld(A, descA)
         include 'misc.h'
         include 'pblas.h'
         real(SP), intent(in), dimension(:,:) :: A
         integer, intent(in), dimension(:,:) :: DESCA
!HPF$    DISTRIBUTE(*,block) :: descA
      end function SLhpf_sget_lld
      extrinsic(    f77_local    ) subroutine                           &
     &pssyev( jobz, uplo, n, A, ia, ja, descA, W, Z, iz, jz, descZ,        &
     &             work, lwork, info )
        include 'pblas.h'
        include 'misc.h'
        character(LEN=1), intent(in) :: jobz, uplo
        integer, intent(in) :: n, ia, ja, iz, jz, lwork
!       Write-around for pghpf bug
!        integer, intent(in), dimension(*) :: descA, descZ
        integer, intent(in), dimension(DLEN_,1) :: descA, descZ
        real(SP), intent(inout) :: A(descA(LLD_,1),*)
        real(SP), intent(out) :: W(*), Z(descZ(LLD_,1),*), work(*)
        integer, intent(out) :: info
      end subroutine pssyev
      END INTERFACE

      ictxt = descA(CTXT_,1)
      call blacs_gridinfo(ictxt, nprow, npcol, myrow, mycol)
      if (myrow .ne. -1) then
         descA(LLD_,1)  = SLhpf_sget_lld(A, descA)
         if (present(Z)) then
            descZ(LLD_,1)  = SLhpf_sget_lld(Z, descZ)

            call pssyev(jobz, uplo, n, A, ia, ja, descA, W, Z, iz, jz,  &
     &               descZ, work1, -1, info)
            lwork = work1(1)
            allocate(work(lwork))
            call pssyev(jobz, uplo, n, A, ia, ja, descA, W, Z, iz, jz,  &
     &               descZ, work, lwork, info)
         else
            descZ(LLD_,1) = descA(LLD_,1)
            call pssyev(jobz, uplo, n, A, ia, ja, descA, W, Z1, iz, jz, &
     &               descZ, work1, -1, info)
            lwork = work1(1)
            allocate(work(lwork))
            call pssyev(jobz, uplo, n, A, ia, ja, descA, W, Z1, iz, jz, &
     &               descZ, work, lwork, info)
         endif
      endif

      return
      end
