      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_strsm1(side, uplo, transA, diag, m, n, alpha, A, &
     &                        ia, ja, descA, B, ib, jb, descB)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     University of Tennessee, Knoxville
!     Code contributors: R. Clint Whaley
!     Last modified by: C. A. Papadopoulos
!
      include 'pblas.h'
      include 'misc.h'
      character(LEN=1), intent(in) :: side, uplo, transA, diag
      integer, intent(in) :: m, n, ia, ja, ib, jb
      integer, dimension(:,:), intent(inout) :: descA, descB
      real(SP), intent(in) :: alpha
      real(SP), intent(in), dimension(:,:) :: A
      real(SP), intent(inout), dimension(:,:) :: B
!HPF$ INHERIT A, B
!HPF$ DISTRIBUTE(*,block) :: descA, descB

      integer :: ictxt, nprow, npcol, myrow, mycol, i

      INTERFACE
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridinfo( icontxt, nprow, npcol, myprow, mypcol )
         integer, intent(in) :: icontxt
         integer, intent(out) :: nprow, npcol, myprow, mypcol
      end subroutine blacs_gridinfo
      extrinsic(    f77_local    ) subroutine                           &
     &pstrsm(side, uplo, transA, diag, m, n, alpha, A, ia, ja, descA,   &
     &       B, ib, jb, descb)
        include 'pblas.h'
        include 'misc.h'
        character(LEN=1), intent(in) :: side, uplo, transA, diag
        integer, intent(in) :: m, n, ia, ja, ib, jb
!       Write-around for pghpf bug
!        integer, intent(inout), dimension(*) :: descA, descB
        integer, intent(inout), dimension(DLEN_,1) :: descA, descB
        real(SP), intent(in) :: alpha
        real(SP), intent(in), dimension(descA(LLD_),*) :: A
        real(SP), intent(inout), dimension(descB(LLD_),*) :: B
      end subroutine pstrsm
      extrinsic(hpf_local)                                              &
     &integer function SLhpf_sget_lld(A, descA)
         include 'misc.h'
         include 'pblas.h'
         real(SP), intent(in), dimension(:,:) :: A
         integer, intent(in), dimension(:,:) :: DESCA
!HPF$    DISTRIBUTE(*,block) :: descA
      end function SLhpf_sget_lld
      END INTERFACE

      ictxt = descA(CTXT_,1)
      call blacs_gridinfo(ictxt, nprow, npcol, myrow, mycol)
      if (myrow .ne. -1) then
         descA(LLD_,1)  = SLhpf_sget_lld(A, descA)
         descB(LLD_,1)  = SLhpf_sget_lld(B, descB)

         call pstrsm(side, uplo, transA, diag, m, n, alpha, A, ia, ja,  &
     &               descA, B, ib, jb, descB)
      end if

      return
      end
