      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_zgemm2(P, Q, mbA, nbA, mbB, nbB, mbC, nbC,       &
     &                        transA, transB, m, n, k, alpha, A,        &
     &                        ia, ja, descA, B, ib, jb, descB, beta,    &
     &                        C, ic, jc, descC)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     University of Tennessee, Knoxville
!     Code contributors: R. Clint Whaley
!     Last modified by: C. A. Papadopoulos
!
      include 'pblas.h'
      include 'misc.h'
      character(LEN=1), intent(in) :: transA, transB
      integer, intent(in) :: P, Q, mbA, nbA, mbB, nbB, nbC, mbC,        &
     &                       m, n, k, ia, ja, ib, jb, ic, jc
      integer, dimension(:,:), intent(inout) :: descA, descB, descC
      complex(DP), intent(in) :: alpha, beta
      complex(DP), intent(in), dimension(:,:) :: A, B
      complex(DP), intent(inout), dimension(:,:) :: C
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ DISTRIBUTE A(CYCLIC(mbA), CYCLIC(nbA)) ONTO PROC
!HPF$ DISTRIBUTE B(CYCLIC(mbB), CYCLIC(nbB)) ONTO PROC
!HPF$ DISTRIBUTE C(CYCLIC(mbC), CYCLIC(nbC)) ONTO PROC
!HPF$ DISTRIBUTE(*,block) :: descA, descB, descC

      integer :: ictxt, nprow, npcol, myrow, mycol, i, itmp(2)
      integer, dimension(NUMBER_OF_PROCESSORS()) :: pmap

      INTERFACE
      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_zget_procmap(A, desca, P, Q, pmap)
         include 'misc.h'
         complex(DP), intent(in) :: A(:,:)
         integer, intent(inout) :: descA(:,:)
         integer, intent(out) :: P, Q, pmap(:)
!HPF$    DISTRIBUTE(*,block) :: descA
!HPF$    INHERIT A, pmap
      end subroutine SLhpf_zget_procmap
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_get( icontxt, what, val )
         integer, intent(in) :: icontxt, what
         integer, intent(out) :: val(*)
      end subroutine blacs_get
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridmap( icontxt, umap, ldu, nprow, npcol )
         integer, intent(inout) :: icontxt
         integer, intent(in) :: ldu, nprow, npcol
         integer, intent(in) :: umap(ldu,*)
      end subroutine blacs_gridmap
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridinfo( icontxt, nprow, npcol, myprow, mypcol )
         integer, intent(in) :: icontxt
         integer, intent(out) :: nprow, npcol, myprow, mypcol
      end subroutine blacs_gridinfo
      extrinsic(    f77_local    ) subroutine                           &
     &pzgemm(transa, transb, m, n, k, alpha, a, ia, ja, desca, b,       &
     &       ib, jb, descb, beta, c, ic, jc, descc)
        include 'pblas.h'
        include 'misc.h'
        character(LEN=1), intent(in) :: transA, transB
        integer, intent(in) :: m, n, k, ia, ja, ib, jb, ic, jc
!       Write-around for pghpf bug
!        integer, intent(inout), dimension(*) :: descA, descB, descC
        integer, intent(inout), dimension(DLEN_,1) :: descA, descB,     &
     &                                                descC
        complex(DP), intent(in) :: alpha, beta
        complex(DP), intent(in), dimension(descA(LLD_),*) :: A
        complex(DP), intent(in), dimension(descB(LLD_),*) :: B
        complex(DP), intent(inout), dimension(descC(LLD_),*) :: C
      end subroutine pzgemm
      extrinsic(hpf_local)                                              &
     &integer function SLhpf_zget_lld(A, descA)
         include 'misc.h'
         include 'pblas.h'
         complex(DP), intent(in), dimension(:,:) :: A
         integer, intent(in), dimension(:,:) :: DESCA
!HPF$    DISTRIBUTE(*,block) :: descA
      end function SLhpf_zget_lld
      extrinsic(    f77_local    ) subroutine                           &
     &blacs_gridexit( icontxt )
         integer, intent(in) :: icontxt
      end subroutine blacs_gridexit
      END INTERFACE

      call SLhpf_zget_procmap(A, descA, nprow, npcol, pmap)
      call blacs_get(-1, 0, itmp)
      ictxt = itmp(1)
      call blacs_gridmap(ictxt, pmap, nprow, nprow, npcol)
      call blacs_gridinfo(ictxt, nprow, npcol, myrow, mycol)
      if (myrow .ne. -1) then
         descA(RSRC_,1) = 0
         descA(CSRC_,1) = 0
         descA(CTXT_,1) = ictxt
         descA(LLD_,1)  = SLhpf_zget_lld(A, descA)
         descB(RSRC_,1) = 0
         descB(CSRC_,1) = 0
         descB(CTXT_,1) = ictxt
         descB(LLD_,1)  = SLhpf_zget_lld(B, descB)
         descC(RSRC_,1) = 0
         descC(CSRC_,1) = 0
         descC(CTXT_,1) = ictxt
         descC(LLD_,1)  = SLhpf_zget_lld(C, descC)

         call pzgemm(transA, transB, m, n, k, alpha, A, ia, ja, descA,  &
     &               B, ib, jb, descB, beta, C, ic, jc, descC)
         call blacs_gridexit(ictxt)
      end if

      return
      end
