      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_zget_procmap(A, desca, P, Q, pmap)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     University of Tennessee, Knoxville
!     Code contributors: R. Clint Whaley
!     Last modified by: C. A. Papadopoulos
!
      USE HPF_LOCAL_LIBRARY
      include 'pblas.h'
      include 'misc.h'
      complex(DP), intent(in) :: A(:,:)
      integer, intent(inout) :: descA(:,:)
      integer, intent(out) :: P, Q, pmap(:)
!HPF$ DISTRIBUTE(*,block) :: descA
!HPF$ INHERIT A, pmap
      INTERFACE
      extrinsic(    f77_local    ) subroutine                           &
     &SLhpf_get_hpf2sys_map(h2smap, Np0, Iam0)
         integer, intent(in) :: Np0, Iam0
         integer, intent(out) :: h2smap(*)
      end subroutine SLhpf_get_hpf2sys_map
      extrinsic(hpf_local) subroutine SLhpf_abort(errno)
         integer, intent(in) :: errno
      end subroutine SLhpf_abort
      END INTERFACE

      logical :: FIRST_TIME
      integer :: src, i, j, h
      integer :: it(2)
      integer, allocatable :: h2smap(:)

      save h2smap
!
!     First time, start BLACS machine and establish procid mappings
!
      if (.not.allocated(h2smap)) then
         allocate( h2smap(NUMBER_OF_PROCESSORS()) )
         call SLhpf_get_hpf2sys_map(h2smap, NUMBER_OF_PROCESSORS(),     &
     &                              MY_PROCESSOR())
      end if
!
!     Find HPF ID of src processor
!
      descA(RSRC_,1) = -2 ; descA(CSRC_,1) = -2
      it = 1
      call global_to_local(A, it, NCOPIES=i, PROCS=pmap)
      src = minval(pmap(1:i))

      call GLOBAL_DISTRIBUTION(A, PROCESSORS_RANK=i,                    &
     &                         PROCESSORS_SHAPE=it)
      if (i .eq. 1) then                           ! 1-D process grid
         if (descA(M_,1) .eq. descA(MB_,1)) then
            P = 1
            Q = it(1)
         else if (descA(N_,1) .eq. descA(NB_,1)) then
            P = it(1)
            Q = 1
         else
            print*,'Non-distributed dimension not collapsed!!'
            call SLhpf_abort(-1)
         end if
         i = P * Q
         do j = 1, i
            it(1) = j
            call abstract_to_physical(A, it, pmap(j))
!
!           Check to see if this process is the matrix source process
!
            if (pmap(j) .eq. src) then
               if (P .eq. 1) then
                  descA(RSRC_,1) = 0
                  descA(CSRC_,1) = j-1
               else
                  descA(RSRC_,1) = j-1
                  descA(CSRC_,1) = 0
               end if
            end if
!
!           Translate HPF ID to system ID
!
            pmap(j) = h2smap(pmap(j)+1)
         end do
      else  ! 2-D distribution; rank > 3 do not call this routine
         P = it(1); Q = it(2)
         do j = 1, Q
            it(2) = j
            h = 1 + (j-1)*P
            do i = 1, P
               it(1) = i
               call abstract_to_physical(A, it, pmap(h))
!
!              Check to see if this process is the matrix source process
!
               if (pmap(h) .eq. src) then
                  descA(RSRC_,1) = i-1
                  descA(CSRC_,1) = j-1
               end if
!
!              Translate HPF ID to system ID
!
               pmap(h) = h2smap(pmap(h)+1)
               h = h + 1
            end do
         end do
      end if
      if (descA(RSRC_,1).eq.-2) then
         print*,'Matrix source',src,' not in process grid'
         call SLhpf_abort(-1)
      end if

      return
      end

