      subroutine SLhpf_cdescset3_v(A, descA, B, descB, C, descC, P0, Q0,  &
     &                           info0)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by C. A. Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      include 'pblas.h'
      include 'misc.h'
      complex(SP), dimension(:,:), intent(in) :: A
      integer, dimension(DLEN_,NUMBER_OF_PROCESSORS()),                 &
     &         intent(out) :: descA
      complex(SP), dimension(:), optional, intent(in) :: B
      complex(SP), dimension(:,:), optional, intent(in) :: C
      integer, optional, dimension(DLEN_,NUMBER_OF_PROCESSORS()),       &
     &         intent(out) :: descB, descC
      integer, optional, intent(out) :: P0, Q0, info0
!HPF$ DISTRIBUTE (*,block) :: descA, descB, descC
!HPF$ INHERIT A, B, C

      integer :: Np, P, Q, P2, Q2, P3, Q3, info, info2, i, j, k
      integer, allocatable, dimension(:) :: pmap, pmap2, pmap3
      logical :: UseAMap=.true.
!HPF$ ALIGN (*) WITH A(*,*) :: pmap, pmap2, pmap3

      INTERFACE
      subroutine SLhpf_cmatinf(A, descA, info0)
         implicit none
         include 'pblas.h'
         include 'misc.h'
         complex(SP), intent(in) :: A(:,:)
         integer, dimension(DLEN_,NUMBER_OF_PROCESSORS()),              &
     &            intent(out) :: descA
         integer, optional, intent(out) :: info0
!HPF$    INHERIT A
!HPF$    DISTRIBUTE(*,block) :: descA
      end subroutine SLhpf_cmatinf
      subroutine SLhpf_cmatinf_v(A, descA, info0)
         implicit none
         include 'pblas.h'
         include 'misc.h'
         complex(SP), intent(in) :: A(:)
         integer, dimension(DLEN_,NUMBER_OF_PROCESSORS()),              &
     &            intent(out) :: descA
         integer, optional, intent(out) :: info0
!HPF$    INHERIT A
!HPF$    DISTRIBUTE(*,block) :: descA
      end subroutine SLhpf_cmatinf_v
      subroutine SLhpf_cgridinf(A, descA, P, Q, pmap, info0)
         include 'pblas.h'
         include 'misc.h'
         complex(SP), intent(in) :: A(:,:)
         integer, dimension(DLEN_,NUMBER_OF_PROCESSORS()),              &
     &            intent(inout) :: descA
         integer, intent(out) :: P, Q, pmap(:)
         integer, optional, intent(out) :: info0
!HPF$    INHERIT A, pmap
!HPF$    DISTRIBUTE(*,block) :: descA
      end subroutine SLhpf_cgridinf
      subroutine SLhpf_cgridinf_v(A, descA, P, Q, pmap, info0)
         include 'pblas.h'
         include 'misc.h'
         complex(SP), intent(in) :: A(:)
         integer, dimension(DLEN_,NUMBER_OF_PROCESSORS()),              &
     &            intent(inout) :: descA
         integer, intent(out) :: P, Q, pmap(:)
         integer, optional, intent(out) :: info0
!HPF$    INHERIT A, pmap
!HPF$    DISTRIBUTE(*,block) :: descA
      end subroutine SLhpf_cgridinf_v
      extrinsic(hpf_local)                                              &
     &function SLhpf_get_context(P, Q, pmap, info)
         integer, dimension(NUMBER_OF_PROCESSORS()) :: SLhpf_get_context
         integer, intent(inout) :: P, Q
         integer, intent(in) ::  pmap(:)
         integer, optional, intent(out) :: info
!HPF$    DISTRIBUTE SLhpf_get_context(block)
!HPF$    INHERIT pmap
      end function SLhpf_get_context
      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_compare_grids(P1, Q1, pmap1, desc1, P2, Q2,      &
     &                               pmap2, desc2, info)
         integer, intent(inout) :: P1, Q1, P2, Q2
         integer, intent(inout), dimension(:) :: pmap1, pmap2
         integer, intent(inout) :: desc1(:,:), desc2(:,:)
         integer, intent(out) :: info
!HPF$    DISTRIBUTE(*,block) :: desc1, desc2
!HPF$    INHERIT pmap1, pmap2
      end subroutine SLhpf_compare_grids
      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_reset_src(P, Q, pmap, desc1, desc2, desc3)
         integer, intent(in) :: P, Q
         integer, intent(in), dimension(:) :: pmap
         integer, intent(inout) :: desc1(:,:)
         integer, optional, intent(inout) :: desc2(:,:), desc3(:,:)
!HPF$    DISTRIBUTE(*,block) :: desc1, desc2, desc3
      end subroutine SLhpf_reset_src
      END INTERFACE
      descA = -9
      if ( present(descB) ) descB = -10
      if ( present(descC) ) descC = -11
      if ( present(P0) ) P0 = -1
      if ( present(Q0) ) Q0 = -1
!
!     Fill in the matrix information
!
      info = 0; info2 = 0
      call SLhpf_cmatinf(A, descA, info)
      if (info .ne. 0) then
         info = info - 100
      end if
      if ( present(B) ) then
         call SLhpf_cmatinf_v(B, descB, info2)
         if (info2 .ne. 0) then
            if (info .eq. 0) info = info2 - 200
            info2 = 0
         end if
         if ( present(C) ) then
            call SLhpf_cmatinf(C, descC, info2)
            if (info2 .ne. 0) then
               if (info .eq. 0) info = info2 - 300
            end if
         end if
      end if
!
!     Return if any matrix was not legally distributed
!
      if ( info.ne.0 ) then
         if (present(info0)) info0 = info
         return
      end if
!
!     Find the gridmap for A's process grid
!
      Np = NUMBER_OF_PROCESSORS()
      allocate( pmap(Np) )
      call SLhpf_cgridinf(A, descA, P, Q, pmap, info)
      if ( info.eq.0 .and. present(B) ) then
         allocate( pmap2(Np) )
         call SLhpf_cgridinf_v(B, descB, P2, Q2, pmap2, info)
         if (info .eq. 0) then
            call SLhpf_compare_grids(P, Q, pmap, descA, P2, Q2, pmap2,  &
     &                               descB, info)
            if (info .eq. 1) info = 0
         end if
         if (info .ne. 0) info = -(200+CTXT_)
         if ( info.eq.0 .and. present(C) ) then
            allocate( pmap3(Np) )
            call SLhpf_cgridinf(C, descC, P3, Q3, pmap3, info)
            if (info .eq. 0) then
               call SLhpf_compare_grids(P, Q, pmap, descA, P3, Q3,      &
     &                                  pmap3, descC, info)
               if (info .eq. 1) then
                  call SLhpf_compare_grids(P3, Q3, pmap3, descC,        &
     &                                     P2, Q2, pmap2, descB, info)
               end if
            end if
            if (info .ne. 0) info = -(300+CTXT_)
            deallocate( pmap3 )
         end if
         deallocate( pmap2 )
      end if
      if (info .eq. 0) then
         descA(CTXT_,:) = SLhpf_get_context(P, Q, pmap, info)
         if (info .ne. 0) then
            call SLhpf_reset_src(P, Q, pmap, descA, descB, descC)
            info = 0
         end if
         if ( present(B) ) descB(CTXT_,:) = descA(CTXT_,:)
         if ( present(C) ) descC(CTXT_,:) = descA(CTXT_,:)
         if ( present(P0) ) P0 = P
         if ( present(Q0) ) Q0 = Q
      end if

      deallocate( pmap )
      if (present(info0)) info0 = info

      return
      end
