      real function cmatnrm(A)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      include 'misc.h'
      complex(SP), intent(in), dimension(:,:) :: A
      integer :: i
      real(SP) :: maxnrm, tmp

      maxnrm = 0.0E0
      do i = 1, size(A,1)
         tmp = sum( abs(A(i,:)) )
         if (tmp .gt. maxnrm) maxnrm = tmp
      end do

      cmatnrm = maxnrm

      RETURN
      END

      subroutine ctrsminfo( thresh, alpha, ngrid, nmat, nop, Pval, Qval,&
     &                      mAval, nAval, mbAval, nbAval, rsrcAval,     &
     &                      csrcAval, mBval, nBval, mbBval, nbBval,     &
     &                      rsrcBval, csrcBval, SIDEval, UPLOval,       &
     &                      TRANSval, DIAGval, Mval, Nval, IAval, JAval,&
     &                      IBval, JBval )
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      include 'misc.h'
      include 'pblas.h'
      real, intent(out) :: thresh
      complex(SP), intent(out) :: alpha
      integer, intent(out) :: ngrid, nmat, nop
      integer, pointer, dimension(:) :: DIAGval, IAval, IBval, JAval,   &
     &         JBval, Mval, Nval, Pval, Qval, SIDEval, TRANSval,        &
     &         UPLOval, csrcAval, csrcBval, mAval, mBval, mbAval,       &
     &         mbBval, nAval, nBval, nbAval, nbBval, rsrcAval, rsrcBval
      character(LEN=1), allocatable, dimension(:) :: ctmp
      integer, parameter :: nin=11
      integer :: i

      open(nin, file='ctrsm.dat', STATUS='OLD')

      read(nin,*) ngrid
      allocate( Pval(ngrid), Qval(ngrid) )
      read(nin,*) ( Pval(i), i = 1, ngrid )
      read(nin,*) ( Qval(i), i = 1, ngrid )

      read(nin,*) nmat
      allocate( mAval(nmat), nAval(nmat), mbAval(nmat), nbAval(nmat),   &
     &          rsrcAval(nmat), csrcAval(nmat), mBval(nmat),            &
     &          nBval(nmat), mbBval(nmat), nbBval(nmat), rsrcBval(nmat),&
     &          csrcBval(nmat) )

      read(nin,*) ( mAval(i), i = 1, nmat )
      read(nin,*) ( nAval(i), i = 1, nmat )
      read(nin,*) ( mbAval(i), i = 1, nmat )
      read(nin,*) ( nbAval(i), i = 1, nmat )
      read(nin,*) ( rsrcAval(i), i = 1, nmat )
      read(nin,*) ( csrcAval(i), i = 1, nmat )
      read(nin,*) ( mBval(i), i = 1, nmat )
      read(nin,*) ( nBval(i), i = 1, nmat )
      read(nin,*) ( mbBval(i), i = 1, nmat )
      read(nin,*) ( nbBval(i), i = 1, nmat )
      read(nin,*) ( rsrcBval(i), i = 1, nmat )
      read(nin,*) ( csrcBval(i), i = 1, nmat )

      read(nin,*) nop
      allocate( Mval(nop), Nval(nop), IAval(nop), JAval(nop),           &
     &          IBval(nop), JBval(nop), SIDEval(nop), UPLOval(nop),     &
     &          TRANSval(nop), DIAGval(nop) )
!
!     Store character info in an integer array to get around pghpf compiler
!     error with having character arrays have the pointer attribute
!
      allocate( ctmp(nop) )
      read(nin,*) ( ctmp(i), i = 1, nop )
      do i = 1, nop
         SIDEval(i) = iachar( ctmp(i) )
      end do

      read(nin,*) ( ctmp(i), i = 1, nop )
      do i = 1, nop
         UPLOval(i) = iachar( ctmp(i) )
      end do

      read(nin,*) ( ctmp(i), i = 1, nop )
      do i = 1, nop
         TRANSval(i) = iachar( ctmp(i) )
      end do

      read(nin,*) ( ctmp(i), i = 1, nop )
      do i = 1, nop
         DIAGval(i) = iachar( ctmp(i) )
      end do

      deallocate( ctmp )
      read(nin,*) ( Mval(i), i = 1, nop )
      read(nin,*) ( Nval(i), i = 1, nop )
      read(nin,*) ( IAval(i), i = 1, nop )
      read(nin,*) ( JAval(i), i = 1, nop )
      read(nin,*) ( IBval(i), i = 1, nop )
      read(nin,*) ( JBval(i), i = 1, nop )
      read(nin,*) alpha
      read(nin,*) thresh

      close(nin)

      return
      end subroutine ctrsminfo

      program ctrsmtst

!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     University of Tennessee, Knoxville
!     Code contributors: R. Clint Whaley
!     Last modified by: C. A. Papadopoulos
!
      include 'misc.h'
      complex(SP), allocatable, dimension(:,:) :: A, X, B

      INTERFACE
      extrinsic(hpf_local) subroutine SLhpf_exit()
      end subroutine SLhpf_exit

      subroutine ctrsmtst2(thresh, alpha, N0, P, Q, mb_A, nb_A, mb_B,   &
     &                     nb_B, rsrc_A, csrc_A, rsrc_B, csrc_B, Nop,   &
     &                     SIDEval, UPLOval, TRANSval, DIAGval, Mval,   &
     &                     Nval, IAval, JAval, IBval, JBval, A, B,      &
     &                     npass, nfail, nskip, ninfo, nbyp)
         include 'misc.h'
         integer, intent(in) :: N0, P, Q, mb_A, nb_A, mb_B, nb_B,       &
     &                          rsrc_A, csrc_A, rsrc_B, csrc_B, Nop
         integer, intent(in), dimension(:) :: DIAGval, IAval, IBval,    &
     &                                        JAval, JBval, Mval, Nval, &
     &                                        SIDEval, TRANSval,        &
     &                                        UPLOval
         integer, intent(out) :: npass, nfail, nskip, ninfo, nbyp
         real, intent(in) :: thresh
         complex(SP), intent(in) :: alpha
         complex(SP), dimension(:,:) :: A, B
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ TEMPLATE, DIMENSION(N0, N0) :: ATEMP, BTEMP
!HPF$ DISTRIBUTE ATEMP(cyclic(mb_A), cyclic(nb_A)) ONTO PROC
!HPF$ DISTRIBUTE BTEMP(cyclic(mb_B), cyclic(nb_B)) ONTO PROC
!HPF$ ALIGN A(I,J) WITH ATEMP(rsrc_A*mb_A+I, csrc_A*nb_A+J)
!HPF$ ALIGN B(I,J) WITH BTEMP(rsrc_B*mb_B+I, csrc_B*nb_B+J)
      end subroutine ctrsmtst2




      subroutine ctrsminfo(thresh, alpha, ngrid, nmat, nop, Pval, Qval, &
     &                     mAval, nAval, mbAval, nbAval, rsrcAval,      &
     &                     csrcAval, mBval, nBval, mbBval, nbBval,      &
     &                     rsrcBval, csrcBval, SIDEval, UPLOval,        &
     &                     TRANSval, DIAGval, Mval, Nval, IAval, JAval, &
     &                     IBval, JBval)
         include 'misc.h'
         real, intent(out) :: thresh
         complex(SP), intent(out) :: alpha
         integer, intent(out) :: ngrid, nmat, nop
         integer, pointer, dimension(:) :: DIAGval, IAval, IBval, JAval,&
     &                                     JBval, Mval, Nval, Pval,     &
     &                                     Qval, SIDEval, TRANSval,     &
     &                                     UPLOval, csrcAval, csrcBval, &
     &                                     mAval, mBval, mbAval, mbBval,&
     &                                     nAval, nBval, nbAval, nbBval,&
     &                                     rsrcAval, rsrcBval
      end subroutine ctrsminfo
      END INTERFACE

      integer :: igrid, imat, itest, k, nbyp, nbypa, nfai, nfail, ngrid,&
     &           ninf, ninfo, nmat, nop, npas, npass, nski, nskip,      &
     &           ntest
      integer, pointer, dimension(:) :: DIAGval, IAval, IBval, JAval,   &
     &                                  JBval, M_Aval, M_Bval, Mval,    &
     &                                  N_Aval, N_Bval, Nval, Pval,     &
     &                                  Qval, SIDEval, TRANSval,        &
     &                                  UPLOval, csrc_Aval, csrc_Bval,  &
     &                                  mb_Aval, mb_Bval, nb_Aval,      &
     &                                  nb_Bval, rsrc_Aval, rsrc_Bval
      real :: thresh
      complex(SP) :: alpha

      call ctrsminfo(thresh, alpha, ngrid, nmat, nop, Pval, Qval,       &
     &               M_Aval, N_Aval, mb_Aval, nb_Aval, rsrc_Aval,       &
     &               csrc_Aval, M_Bval, N_Bval, mb_Bval, nb_Bval,       &
     &               rsrc_Bval, csrc_Bval, SIDEval, UPLOval, TRANSval,  &
     &               DIAGval, Mval, Nval, IAval, JAval, IBval, JBval)
      itest = 1
      nfail = 0; npass = 0; nskip = 0; ninfo = 0; ntest = 0; nbypa = 0
!
!     Find upper bound for template size
!
      k = max( maxval(MB_Aval), maxval(NB_Aval), maxval(MB_Bval),       &
     &         maxval(NB_Bval) )
      k = k * max( maxval(rsrc_Aval), maxval(csrc_Aval),                &
     &             maxval(rsrc_Bval), maxval(csrc_Bval) )
      k = k + max( maxval(M_Aval), maxval(N_Aval), maxval(M_Bval),      &
     &             maxval(N_Bval) )
      do igrid = 1, ngrid
         do imat = 1, nmat
            write(*,*) ' '
            write(*,5000)
            write(*,1000) itest
            write(*,2000) Pval(igrid), Qval(igrid)
            write(*,3000) M_Aval(imat), N_Aval(imat), mb_Aval(imat),    &
     &                    nb_Aval(imat), rsrc_Aval(imat),               &
     &                    csrc_Aval(imat)
            write(*,4000) M_Bval(imat), N_Bval(imat), mb_Bval(imat),    &
     &                    nb_Bval(imat), rsrc_Bval(imat),               &
     &                    csrc_Bval(imat)
            write(*,5000)
            allocate( A(M_Aval(imat), N_Aval(imat)) )
            allocate( B(M_Bval(imat), N_Bval(imat)) )
            A = (-99.9E10, -99.8E10)
            B = (-99.7E10, -99.6E10)
            call ctrsmtst2(thresh, alpha, k, Pval(igrid), Qval(igrid),  &
     &                     mb_Aval(imat), nb_Aval(imat), mb_Bval(imat), &
     &                     nb_Bval(imat), rsrc_Aval(imat),              &
     &                     csrc_Aval(imat), rsrc_Bval(imat),            &
     &                     csrc_Bval(imat), Nop, SIDEval, UPLOval,      &
     &                     TRANSval, DIAGval, Mval, Nval, IAval, JAval, &
     &                     IBval, JBval, A, B, npas, nfai, nski, ninf,  &
     &                     nbyp)
            npass = npass + npas
            nfail = nfail + nfai
            nskip = nskip + nski
            ninfo = ninfo + ninf
            nbypa = nbypa + nbyp
            write(*,5000)
            write(*,6000) itest
            write(*,5000)
            write(*,*) ' '
            deallocate(A)
            deallocate(B)
            itest = itest + 1
         end do
      end do
      deallocate( Pval, Qval, m_Aval, n_Aval, mb_Aval, nb_Aval,         &
     &            rsrc_Aval, csrc_Aval, m_Bval, n_Bval, mb_Bval,        &
     &            nb_Bval, rsrc_Bval, csrc_Bval, SIDEval, UPLOval,      &
     &            TRANSval, DIAGval, Mval, Nval )

      write(*,*) ' '
      write(*,*) ' '
      write(*,*) ' '
      write(*,5000)
      write(*,5000)
      write(*,7000) Nop*(itest-1), npass, nfail, nskip, ninfo, nbypa
      write(*,5000)
      write(*,5000)
      call SLhpf_exit()

 1000 format(x,'Begin test batch #',i6,':')
 2000 format(x,'P =',i4, '; Q =',i4,';')
 3000 format(x,'M_A =',i6,'; N_A =',i6,'; MB_A =',i4,'; NB_A =',i4,     &
     &       '; RSRC_A =',i3,'; CSRC_A =',i3)
 4000 format(x,'M_B =',i6,'; N_B =',i6,'; MB_B =',i4,'; NB_B =',i4,     &
     &       '; RSRC_B =',i3,'; CSRC_B =',i3)
 5000 format(x,'******************************************************' &
     &         '*************************')
 6000 format(x,'Done  test batch #',i6,'.')
 7000 format(x,I5,' TESTS:',I5,' PASSED,',I5,' FAILED,',I5,' SKIPPED,', &
     &       I5,' BAD INFO',I5,' BYPASS')

      stop
      end

      subroutine ctrsmtst2(thresh, alpha, N0, P, Q, mb_A, nb_A, mb_B,   &
     &                     nb_B, rsrc_A, csrc_A, rsrc_B, csrc_B, Nop,   &
     &                     SIDEval, UPLOval, TRANSval, DIAGval,         &
     &                     Mval, Nval, IAval, JAval, IBval, JBval, A, B,&
     &                     npass, nfail, nskip, ninfo, nbyp)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      USE HPF_LAPACK
      include 'misc.h'
      integer, intent(in) :: N0, P, Q, mb_A, nb_A, mb_B, nb_B,          &
     &                       rsrc_A, csrc_A, rsrc_B, csrc_B, Nop
      integer, intent(in), dimension(:) :: DIAGval, IAval, IBval, JAval,&
     &                                     JBval, Mval, Nval, SIDEval,  &
     &                                     TRANSval, UPLOval
      integer, intent(out) :: npass, nfail, nskip, ninfo, nbyp
      real, intent(in) :: thresh
      complex(SP), intent(in) :: alpha
      complex(SP), dimension(:,:) :: A, B
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ TEMPLATE, DIMENSION(N0, N0) :: ATEMP, BTEMP
!HPF$ DISTRIBUTE ATEMP(cyclic(mb_A), cyclic(nb_A)) ONTO PROC
!HPF$ DISTRIBUTE BTEMP(cyclic(mb_B), cyclic(nb_B)) ONTO PROC
!HPF$ ALIGN A(I,J) WITH ATEMP(rsrc_A*mb_A+I, csrc_A*nb_A+J)
!HPF$ ALIGN B(I,J) WITH BTEMP(rsrc_B*mb_B+I, csrc_B*nb_B+J)

      character(LEN=1) :: side, uplo, trans, diag
      character*7 stat
      complex(SP), allocatable, dimension(:,:) :: A0, X
      real(SP) sres, myreal, myimag
      integer :: i, j, k, ia, ja, ib, jb, info, count0, count, crate
      integer :: M, N, AM, AN, BM, BN, opN,                             &
     &           IAbeg, IAend, IAinc, JAbeg, JAend, JAinc,              &
     &           IBbeg, IBend, IBinc, JBbeg, JBend, JBinc
      real(DP) :: time

      INTERFACE
      real function ctrslvcheck(side, uplo, trans, diag, alpha, A, x,   &
     &                          b)
      include 'misc.h'
      character(LEN=1), intent(in) :: side, uplo, trans, diag
      complex(SP), intent(in) :: alpha
      complex(SP), dimension(:,:), intent(inout) :: A
      complex(SP), dimension(:,:), intent(in) :: x, b
      end function ctrslvcheck
      END INTERFACE

      write(*,1000)
      write(*,2000)

      npass = 0; nfail = 0; nskip = 0; ninfo = 0; nbyp = 0
      do k = 1, Nop
         side = achar( SIDEval(k) )
         uplo = achar( UPLOval(k) )
         trans = achar( TRANSval(k) )
         diag = achar( DIAGval(k) )
         M = Mval(k)
         N = Nval(k)
         IA = IAval(k)
         JA = JAval(k)
         IB = IBval(k)
         JB = JBval(k)
         write(*,3000) 'RUNNING', M, N, side, uplo, trans, diag, IA, JA,&
     &                 IB, JB, 0.0E0, 0.0E0
         if (side.eq.'l' .or. side.eq.'L') then
            opN = M
         else
            opN = N
         end if
         AM = opN + IA-1
         AN = opN + JA-1
         BM = M + IB-1
         BN = N + JB-1
         if ( (AM.le.size(A,1)) .and. (AN.le.size(A,2)) .and.           &
     &        (BM.le.size(B,1)) .and. (BN.le.size(B,2)) ) then
            do j = JA, An
               do i = iA, Am
                  call random_number(myreal)
                  call random_number(myimag)
                  A(I,J) = cmplx(myreal-0.5E0, myimag-0.5E0)
               end do
            end do
            do j = JB, Bn
               do i = iB, Bm
                  call random_number(myreal)
                  call random_number(myimag)
                  B(I,J) = cmplx(myreal-0.5E0, myimag-0.5E0)
               end do
            end do
!
!           Make A diagonally dominant, ensuring our matrix is invertable
!
            if (diag.eq.'U' .or. diag.eq.'u') then
               sres = 1.0E0 / (1.0E0 * opN)
               A(IA:AM, JA:AN) = A(IA:AM, JA:AN) * sres
            else
               sres = 0.5E0 * opN
               forall(i=0:opN-1) A(ia+i,ja+i) = A(ia+i,ja+i) +          &
     &                                          cmplx(sres,sres)
            end if
            if (thresh .ge. 0.0E0) then
               allocate( X(M, N) )
               X = B(IB:BM, JB:BN)
            end if

            call system_clock(count0, crate)
            call la_trsm(A(IA:AM, JA:AN), B(IB:BM, JB:BN), side, uplo,  &
     &                   trans, diag, alpha)
            call system_clock(count)
            time = (1.0D0*(count-count0))/(1.0D0*crate)

            sres = -1.0E0
            if (thresh .ge. 0.0E0) then
               sres = ctrslvcheck(side, uplo, trans, diag, alpha,       &
     &                            A(IA:AM, JA:AN), B(IB:BM, JB:BN), X)
               if (sres .gt. thresh) then
                  stat = 'FAILED '
                  nfail = nfail + 1
               else
                  stat = 'PASSED '
                  npass = npass + 1
               end if
               deallocate( X )
            else
               nbyp = nbyp + 1
               stat = 'BYPASS '
               sres = 0.0E0
            end if
         else
            stat = 'SKIPPED'
            nskip = nskip + 1
         end if
         write(*,3000) stat, M, N, side, uplo, trans, diag, IA, JA,     &
     &                 IB, JB, sres, time
      end do
      write(*,4000) Nop, npass, nfail, nskip, ninfo, nbyp

 1000 format(' STATUS     M     N SID UPL TRA DIA    IA    JA    IB'     &
     &       '    JB     RESID WALLTIME')
 2000 format('======= ===== ===== === === === === ===== ===== ====='     &
     &       ' ===== ========= ========')
 3000 format(a7, 2I6,2x,a1,3x,a1,3x,a1,3x,a1,4I6,x, E9.1, F9.1)
 4000 format(x,I5,' TESTS:',I5,' PASSED,',I5,' FAILED,',I5,' SKIPPED,', &
     &       I5,' BAD INFO', I5, ' BYPASS.')

      RETURN
      END


      real function ctrslvcheck(side, uplo, trans, diag, alpha, A, x,   &
     &                          b)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      include 'misc.h'
      character(LEN=1), intent(in) :: side, uplo, trans, diag
      complex(SP), intent(in) :: alpha
      complex(SP), dimension(:,:), intent(inout) :: A
      complex(SP), dimension(:,:), intent(in) :: x, b
      integer :: m, n, i, j
      complex(SP), allocatable, dimension(:,:) :: Ax_b
      real(SP), allocatable, dimension(:) :: work(:)
      real(SP) :: normA, normx, eps, num, den, nrm, maxnrm
      INTERFACE
      real function cmatnrm(A)
         include 'misc.h'
         complex(SP), intent(in), dimension(:,:) :: A
      end function cmatnrm
      END INTERFACE
!
!     For ease of calculation, explicitly form op(A)
!
      n = size(A, 1)
      if (diag.eq.'U' .or. diag.eq.'u') then
         forall(i=1:n) A(i,i) = (1.0E0, 0.0E0)
      end if
      if (uplo.eq.'U' .or. uplo.eq.'u') then
         forall(i=1:n, j=1:n, i.gt.j) A(i,j) = (0.0E0, 0.0E0)
      else
         forall(i=1:n, j=1:n, i.lt.j) A(i,j) = (0.0E0, 0.0E0)
      end if
      if (trans.eq.'T' .or. trans.eq.'t') then
         A = transpose(A)
      else if (trans.eq.'C' .or. trans.eq.'c') then
         A = transpose(A)
         forall( i=1:n, j=1:n ) A(i,j) = conjg( A(i,j) )
      end if
!
!     Calculate norm of A and machine epsilon
!
      normA = cmatnrm(A)
      eps = epsilon(0.0E0)

      m = size(B,1)
      n = size(B,2)
      allocate( Ax_b(m, n) )
      allocate( work(m) )
!
!     Check solve: ||Ax - b|| / ( ||A|| * ||x|| * N * eps)
!
      maxnrm = 0.0
      den = normA * eps * N
      if (side.eq.'R' .or. side.eq.'r') then
         Ax_b = matmul(x, A) - alpha*b
      else
         Ax_b = matmul(A, x) - alpha*b
      end if
      do i = 1, n
         work(:) = abs( Ax_b(:,i) )
         num = maxval( work(:) )
         work(:) = abs( x(:,i) )
         nrm = num / ( den * maxval( work(:) ) )
         if (nrm .gt. maxnrm) maxnrm = nrm
      end do
      ctrslvcheck = maxnrm

      deallocate( Ax_b )
      deallocate( work )

      return
      end



