      double precision function dmatnrm(A)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      include 'misc.h'
      real(DP), intent(in), dimension(:,:) :: A
      integer :: i
      real(DP) :: maxnrm, tmp

      maxnrm = 0.0D0
      do i = 1, size(A,1)
         tmp = sum( abs(A(i,:)) )
         if (tmp .gt. maxnrm) maxnrm = tmp
      end do

      dmatnrm = maxnrm

      RETURN
      END

      subroutine dgemminfo( thresh, alpha, beta, ngrid, nmat, nop, Pval,&
     &                      Qval, mAval, nAval, mbAval, nbAval,         &
     &                      rsrcAval, csrcAval, mBval, nBval, mbBval,   &
     &                      nbBval, rsrcBval, csrcBval, mCval, nCval,   &
     &                      mbCval, nbCval, rsrcCval, csrcCval, TAval,  &
     &                      TBval, Mval, Nval, Kval, IAval, JAval,      &
     &                      IBval, JBval, ICval, JCval )
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      include 'misc.h'
      include 'pblas.h'
      real, intent(out) :: thresh
      real(DP), intent(out) :: alpha, beta
      integer, intent(out) :: ngrid, nmat, nop
      integer, pointer, dimension(:) :: IAval, IBval, ICval, JAval,     &
     &         JBval, JCval, Kval, Mval, Nval, Pval, Qval, TAval, TBval,&
     &         csrcAval, csrcBval, csrcCval, mAval, mBval, mCval,       &
     &         mbAval, mbBval, mbCval, nAval, nBval, nCval, nbAval,     &
     &         nbBval, nbCval, rsrcAval, rsrcBval, rsrcCval
      character(LEN=1), allocatable, dimension(:) :: ctmp
      integer, parameter :: nin=11
      integer :: i

      open(nin, file='dgemm.dat', STATUS='OLD')

      read(nin,*) ngrid
      allocate( Pval(ngrid), Qval(ngrid) )
      read(nin,*) ( Pval(i), i = 1, ngrid )
      read(nin,*) ( Qval(i), i = 1, ngrid )

      read(nin,*) nmat
      allocate( mAval(nmat), nAval(nmat), mbAval(nmat), nbAval(nmat),   &
     &          rsrcAval(nmat), csrcAval(nmat), mBval(nmat),            &
     &          nBval(nmat), mbBval(nmat), nbBval(nmat), rsrcBval(nmat),&
     &          csrcBval(nmat), mCval(nmat), nCval(nmat), mbCval(nmat), &
     &          nbCval(nmat), rsrcCval(nmat), csrcCval(nmat) )

      read(nin,*) ( mAval(i), i = 1, nmat )
      read(nin,*) ( nAval(i), i = 1, nmat )
      read(nin,*) ( mbAval(i), i = 1, nmat )
      read(nin,*) ( nbAval(i), i = 1, nmat )
      read(nin,*) ( rsrcAval(i), i = 1, nmat )
      read(nin,*) ( csrcAval(i), i = 1, nmat )
      read(nin,*) ( mBval(i), i = 1, nmat )
      read(nin,*) ( nBval(i), i = 1, nmat )
      read(nin,*) ( mbBval(i), i = 1, nmat )
      read(nin,*) ( nbBval(i), i = 1, nmat )
      read(nin,*) ( rsrcBval(i), i = 1, nmat )
      read(nin,*) ( csrcBval(i), i = 1, nmat )
      read(nin,*) ( mCval(i), i = 1, nmat )
      read(nin,*) ( nCval(i), i = 1, nmat )
      read(nin,*) ( mbCval(i), i = 1, nmat )
      read(nin,*) ( nbCval(i), i = 1, nmat )
      read(nin,*) ( rsrcCval(i), i = 1, nmat )
      read(nin,*) ( csrcCval(i), i = 1, nmat )

      read(nin,*) nop
      allocate( Mval(nop), Nval(nop), IAval(nop), JAval(nop),           &
     &          IBval(nop), JBval(nop), ICval(nop), JCval(nop),         &
     &          Kval(nop), TAval(nop), TBval(nop) )
!
!     Store character info in an integer array to get around pghpf compiler
!     error with having character arrays have the pointer attribute
!
      allocate( ctmp(nop) )
      read(nin,*) ( ctmp(i), i = 1, nop )
      do i = 1, nop
         TAval(i) = iachar( ctmp(i) )
      end do

      read(nin,*) ( ctmp(i), i = 1, nop )
      do i = 1, nop
         TBval(i) = iachar( ctmp(i) )
      end do

      deallocate( ctmp )
      read(nin,*) ( Mval(i), i = 1, nop )
      read(nin,*) ( Nval(i), i = 1, nop )
      read(nin,*) ( Kval(i), i = 1, nop )
      read(nin,*) ( IAval(i), i = 1, nop )
      read(nin,*) ( JAval(i), i = 1, nop )
      read(nin,*) ( IBval(i), i = 1, nop )
      read(nin,*) ( JBval(i), i = 1, nop )
      read(nin,*) ( ICval(i), i = 1, nop )
      read(nin,*) ( JCval(i), i = 1, nop )
      read(nin,*) alpha
      read(nin,*) beta
      read(nin,*) thresh

      close(nin)

      return
      end subroutine dgemminfo

      program dgemmtst
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      include 'misc.h'

      INTERFACE
      extrinsic(hpf_local) subroutine SLhpf_exit()
      end subroutine SLhpf_exit

      subroutine dgemmtst2( thresh, alpha, beta, N0, P, Q, mb_A, nb_A,  &
     &                      rsrc_A, csrc_A, mb_B, nb_B, rsrc_B, csrc_B, &
     &                      mb_C, nb_C, rsrc_C, csrc_C, Nop, Mval, Nval,&
     &                      Kval, TAval, TBval, IAval, JAval, IBval,    &
     &                      JBval, ICval, JCval, A, B, C, npass, nfail, &
     &                      nskip, nbyp )
         include 'misc.h'
         integer, intent(in) :: N0, Nop, P, Q, csrc_A, csrc_B, csrc_C,  &
     &                          mb_A, mb_B, mb_C, nb_A, nb_B, nb_C,     &
     &                          rsrc_A, rsrc_B, rsrc_C
         integer, intent(out) :: nbyp, nfail, npass, nskip
         real, intent(in) :: thresh
         real(DP), intent(in) :: alpha, beta
         integer, intent(in), dimension(:) :: IAval, IBval, ICval,      &
     &                                        JAval, JBval, JCval, Kval,&
     &                                        Mval, Nval, TAval, TBval
         real(DP), dimension(:,:), intent(inout) :: A, B, C
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ TEMPLATE, DIMENSION(N0, N0) :: ATEMP, BTEMP, CTEMP
!HPF$ DISTRIBUTE ATEMP(cyclic(mb_A), cyclic(nb_A)) ONTO PROC
!HPF$ ALIGN A(I,J) WITH ATEMP(rsrc_A*mb_A+I, csrc_A*nb_A+J)
!HPF$ DISTRIBUTE BTEMP(cyclic(mb_B), cyclic(nb_B)) ONTO PROC
!HPF$ ALIGN B(I,J) WITH BTEMP(rsrc_B*mb_B+I, csrc_B*nb_B+J)
!HPF$ DISTRIBUTE CTEMP(cyclic(mb_C), cyclic(nb_C)) ONTO PROC
!HPF$ ALIGN C(I,J) WITH CTEMP(rsrc_C*mb_C+I, csrc_C*nb_C+J)
      end subroutine dgemmtst2

      subroutine dgemminfo( thresh, alpha, beta, ngrid, nmat, nop, Pval,&
     &                      Qval, mAval, nAval, mbAval, nbAval,         &
     &                      rsrcAval, csrcAval, mBval, nBval, mbBval,   &
     &                      nbBval, rsrcBval, csrcBval, mCval, nCval,   &
     &                      mbCval, nbCval, rsrcCval, csrcCval, TAval,  &
     &                      TBval, Mval, Nval, Kval, IAval, JAval,      &
     &                      IBval, JBval, ICval, JCval )
         include 'misc.h'
         integer, intent(out) :: ngrid, nmat, nop
         real, intent(out) :: thresh
         real(DP), intent(out) :: alpha, beta
         integer, pointer, dimension(:) :: IAval, IBval, ICval, JAval,  &
     &         JBval, JCval, Kval, Mval, Nval, Pval, Qval, TAval, TBval,&
     &         csrcAval, csrcBval, csrcCval, mAval, mBval, mCval,       &
     &         mbAval, mbBval, mbCval, nAval, nBval, nCval, nbAval,     &
     &         nbBval, nbCval, rsrcAval, rsrcBval, rsrcCval
      end subroutine dgemminfo
      END INTERFACE

      real(DP) :: alpha, beta
      integer :: igrid, imat, itest, k, nbyp, nbypa, nfai, nfail, ngrid,&
     &           nmat, nop, npas, npass, nski, nskip, ntest
      real :: thresh
      integer, pointer, dimension(:) :: IAval, IBval, ICval, JAval,     &
     &         JBval, JCval, Kval, M_Aval, M_Bval, M_Cval, Mval, N_Aval,&
     &         N_Bval, N_Cval, Nval, Pval, Qval, TAval, TBval,          &
     &         csrc_Aval, csrc_Bval, csrc_Cval, mb_Aval, mb_Bval,       &
     &         mb_Cval, nb_Aval, nb_Bval, nb_Cval, rsrc_Aval, rsrc_Bval,&
     &         rsrc_Cval
      real(DP), allocatable, dimension(:,:) :: A, B, C

      call dgemminfo( thresh, alpha, beta, ngrid, nmat, nop, Pval, Qval,&
     &                M_Aval, N_Aval, mb_Aval, nb_Aval, rsrc_Aval,      &
     &                csrc_Aval, M_Bval, N_Bval, mb_Bval, nb_Bval,      &
     &                rsrc_Bval, csrc_Bval, M_Cval, N_Cval, mb_Cval,    &
     &                nb_Cval, rsrc_Cval, csrc_Cval, TAval, TBval, Mval,&
     &                Kval, Nval, IAval, JAval, IBval, JBval, ICval,    &
     &                JCval )
      itest = 1
      nfail = 0; npass = 0; nskip = 0; ntest = 0; nbypa = 0
!
!     Find upper bound for template size
!
      k = max( maxval(MB_Aval), maxval(NB_Aval), maxval(MB_Bval),       &
     &         maxval(NB_Bval), maxval(MB_Cval), maxval(NB_Cval) )
      k = k * max( maxval(rsrc_Aval), maxval(csrc_Aval),                &
     &             maxval(rsrc_Bval), maxval(csrc_Bval),                &
     &             maxval(rsrc_Cval), maxval(csrc_Cval) )
      k = k + max( maxval(M_Aval), maxval(N_Aval), maxval(M_Bval),      &
     &             maxval(N_Bval), maxval(M_Cval), maxval(N_Cval) )
      do igrid = 1, ngrid
         do imat = 1, nmat
            write(*,*) ' '
            write(*,6000)
            write(*,1000) itest
            write(*,2000) ALPHA, BETA, Pval(igrid), Qval(igrid)
            write(*,3000) M_Aval(imat), N_Aval(imat), mb_Aval(imat),    &
     &                 nb_Aval(imat), rsrc_Aval(imat), csrc_Aval(imat)
            write(*,4000) M_Bval(imat), N_Bval(imat), mb_Bval(imat),    &
     &                 nb_Bval(imat), rsrc_Bval(imat), csrc_Bval(imat)
            write(*,5000) M_Cval(imat), N_Cval(imat), mb_Cval(imat),    &
     &                 nb_Cval(imat), rsrc_Cval(imat), csrc_Cval(imat)
            write(*,6000)
            allocate( A(M_Aval(imat), N_Aval(imat)) )
            allocate( B(M_Bval(imat), N_Bval(imat)) )
            allocate( C(M_Cval(imat), N_Cval(imat)) )
            A = -99.9D10
            B = -99.8D10
            C = -99.7D10
            call dgemmtst2( thresh, alpha, beta, k, Pval(igrid),        &
     &                      Qval(igrid), mb_Aval(imat), nb_Aval(imat),  &
     &                      rsrc_Aval(imat), csrc_Aval(imat),           &
     &                      mb_Bval(imat), nb_Bval(imat),               &
     &                      rsrc_Bval(imat), csrc_Bval(imat),           &
     &                      mb_Cval(imat), nb_Cval(imat),               &
     &                      rsrc_Cval(imat), csrc_Cval(imat), Nop,      &
     &                      TAval, TBval, Mval, Nval, Kval, IAval,      &
     &                      JAval, IBval, JBval, ICval, JCval, A, B, C, &
     &                      npas, nfai, nski, nbyp )
            npass = npass + npas
            nfail = nfail + nfai
            nskip = nskip + nski
            nbypa = nbypa + nbyp
            write(*,6000)
            write(*,7000) itest
            write(*,6000)
            write(*,*) ' '
            deallocate(A)
            deallocate(B)
            deallocate(C)
            itest = itest + 1
         end do
      end do
      deallocate( Pval, Qval, M_Aval, N_Aval, mb_Aval, nb_Aval,         &
     &            rsrc_Aval, csrc_Aval, M_Bval, N_Bval, mb_Bval,        &
     &            nb_Bval, rsrc_Bval, csrc_Bval, M_Cval, N_Cval,        &
     &            mb_Cval, nb_Cval, rsrc_Cval, csrc_Cval, TAval, TBval, &
     &            Mval, Nval, Kval, IAval, JAval, IBval, JBval, ICval,  &
     &            JCval )

      write(*,*) ' '
      write(*,*) ' '
      write(*,*) ' '
      write(*,6000)
      write(*,6000)
      write(*,8000) Nop*(itest-1), npass, nfail, nskip, nbypa
      write(*,6000)
      write(*,6000)
      call SLhpf_exit()

 1000 format('Begin test batch #',i6,':')
 2000 format('ALPHA =',F5.1, '; BETA =',F5.1,'; P =',i4, '; Q =',i4,';')
 3000 format('M_A =',i6,'; N_A =',i6,'; MB_A =',i4,'; NB_A =',i4,       &
     &       '; RSRC_A =',i3,'; CSRC_A =',i3)
 4000 format('M_B =',i6,'; N_B =',i6,'; MB_B =',i4,'; NB_B =',i4,       &
     &       '; RSRC_B =',i3,'; CSRC_B =',i3)
 5000 format('M_C =',i6,'; N_C =',i6,'; MB_C =',i4,'; NB_C =',i4,       &
     &       '; RSRC_C =',i3,'; CSRC_C =',i3)
 6000 format('*******************************************************'  &
     &        '*************************')
 7000 format('Done  test batch #',i6,'.')
 8000 format(I5,' TESTS:',I5,' PASSED,',I5,' FAILED,',I5,' SKIPPED,',I5,&
     &       ' BYPASS.')

      stop
      end

      subroutine dgemmtst2( thresh, alpha, beta, N0, P, Q, mb_A, nb_A,  &
     &                      rsrc_A, csrc_A, mb_B, nb_B, rsrc_B, csrc_B, &
     &                      mb_C, nb_C, rsrc_C, csrc_C, Nop, TAval,     &
     &                      TBval, Mval, Nval, Kval, IAval, JAval,      &
     &                      IBval, JBval, ICval, JCval, A, B, C, npass, &
     &                      nfail, nskip, nbyp )
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      USE HPF_LAPACK
      include 'misc.h'
      integer, intent(in) :: N0, Nop, P, Q, csrc_A, csrc_B, csrc_C,     &
     &                       mb_A, mb_B, mb_C, nb_A, nb_B, nb_C, rsrc_A,&
     &                       rsrc_B, rsrc_C
      integer, intent(out) :: nbyp, nfail, npass, nskip
      real, intent(in) :: thresh
      real(DP), intent(in) :: alpha, beta
      integer, intent(in), dimension(:) :: IAval, IBval, ICval, JAval,  &
     &                                     JBval, JCval, Kval, Mval,    &
     &                                     Nval, TAval, TBval
      real(DP), dimension(:,:), intent(inout) :: A, B, C
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ TEMPLATE, DIMENSION(N0, N0) :: ATEMP, BTEMP, CTEMP
!HPF$ DISTRIBUTE ATEMP(cyclic(mb_A), cyclic(nb_A)) ONTO PROC
!HPF$ ALIGN A(I,J) WITH ATEMP(rsrc_A*mb_A+I, csrc_A*nb_A+J)
!HPF$ DISTRIBUTE BTEMP(cyclic(mb_B), cyclic(nb_B)) ONTO PROC
!HPF$ ALIGN B(I,J) WITH BTEMP(rsrc_B*mb_B+I, csrc_B*nb_B+J)
!HPF$ DISTRIBUTE CTEMP(cyclic(mb_C), cyclic(nb_C)) ONTO PROC
!HPF$ ALIGN C(I,J) WITH CTEMP(rsrc_C*mb_C+I, csrc_C*nb_C+J)

      character(LEN=1) :: transA, transB
      character*4 stat
      real(DP), allocatable, dimension(:,:) :: C0
      real(DP) resid, tmp1, tmp2
      integer :: AM, AN, BM, BN, CM, CN, IAbeg, IAend, IAinc, IBbeg,    &
     &           IBend, IBinc, JAbeg, JAend, JAinc, JBbeg, JBend, JBinc,&
     &           KK, M, N, NRHS, i, ia, ib, ic, j, ja, jb, jc, k, maxN, &
     &           maxNRHS
      real(DP), dimension(NUMBER_OF_PROCESSORS()) :: start, times

      INTERFACE

      double precision function dgemmcheck( A, B, C, ANS, transA,       &
     &                                      transB, alpha, beta )
         include 'misc.h'
         character*1, intent(in) :: transA, transB
         real(DP), intent(in) :: alpha, beta
         real(DP), intent(in), dimension(:,:) :: A, B, ANS
         real(DP), intent(inout), dimension(:,:) :: C
      end function dgemmcheck

      extrinsic(hpf_local) function SLhpf_walltime()
         include 'misc.h'
         include 'pblas.h'
         real(DP), dimension(NUMBER_OF_PROCESSORS()) :: SLhpf_walltime
!HPF$    DISTRIBUTE(block) :: SLhpf_walltime
      end function SLhpf_walltime

      END INTERFACE

      npass = 0; nfail = 0; nskip = 0; nbyp = 0
      write(*,1000)
      write(*,2000)
      do k = 1, Nop
         transA = achar( TAval(k) )
         transB = achar( TBval(k) )
         M = Mval(k)
         N = Nval(k)
         KK = Kval(k)
         IA = IAval(k)
         JA = JAval(k)
         IB = IBval(k)
         JB = JBval(k)
         IC = ICval(k)
         JC = JCval(k)
         if ( transA.eq.'N' .or. transA.eq.'n' ) then
            AM = M + IA-1
            AN = KK + JA-1
         else
            AM = KK + IA-1
            AN = M + JA-1
         end if
         if ( transB.eq.'N' .or. transB.eq.'n' ) then
            BM = KK + IB-1
            BN = N + JB-1
         else
            BM = N + IB-1
            BN = KK + JB-1
         end if
         CM = M + IC-1
         CN = N + JC-1
         write(*,3000) 'RUN-', M, N, KK, transA, IA, JA, transB, IB, JB,&
     &                 IC, JC, 0.0D0, 0.0D0
         if ( (CM.le.size(C,1) .and. CN.le.size(C,2)) .AND.             &
     &        (BM.le.size(B,1) .and. BN.le.size(B,2)) .AND.             &
     &        (AM.le.size(A,1) .and. AN.le.size(A,2)) ) then
            call random_number(A(IA:AM, JA:AN))
            call random_number(B(IB:BM, JB:BN))
            call random_number(C(IC:CM, JC:CN))
            if (thresh .ge. 0.0E0) then
               allocate( C0(M,N) )
               C0 = C(IC:CM, JC:CN)
            end if

            start = SLhpf_walltime()
            call la_gemm(A(IA:AM,JA:AN), B(IB:BM,JB:BN),                &
     &                   C(IC:CM,JC:CN), transA, transB, alpha, beta)
            times = SLhpf_walltime() - start

            if (thresh .ge. 0.0E0) then
               resid = -1.0D0
               resid = dgemmcheck(A(IA:AM, JA:AN), B(IB:BM, JB:BN), C0, &
     &                            C(IC:CM, JC:CN), transA, transB,      &
     &                            alpha, beta)
               if (resid .gt. thresh) then
                  stat = 'FAIL'
                  nfail = nfail + 1
               else
                  stat = 'PASS'
                  npass = npass + 1
               end if
               deallocate( C0 )
            else
               stat = 'BYPA'
               nbyp = nbyp + 1
            end if
         else
            stat = 'SKIP'
            nskip = nskip + 1
         end if
         write(*,3000) stat, M, N, KK, transA, IA, JA, transB, IB, JB,  &
     &                 IC, JC, resid, maxval(times)
      end do
      write(*,4000) Nop, npass, nfail, nskip, nbyp

 1000 format('STAT     M     N     K TA    IA    JA TB    IB    JB'     &
     &       '    IC    JC  RESID WALLTIME')
 2000 format('==== ===== ===== ===== == ===== ===== == ===== ====='     &
     &       ' ===== ===== ====== ========')
 3000 format(a4, 3I6,2x,a1,2I6,2x,a1,4I6,x, E6.1, F9.1)
 4000 format(I5,' TESTS:',I5,' PASSED,',I5,' FAILED,',I5,' SKIPPED,',   &
     &       I5, ' BYPASS.')

      RETURN
      END

      double precision function dgemmcheck( A, B, C, ANS, transA,       &
     &                                      transB, alpha, beta )
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      include 'misc.h'
      character*1, intent(in) :: transA, transB
      real(DP), intent(in) :: alpha, beta
      real(DP), intent(in), dimension(:,:) :: A, B, ANS
      real(DP), intent(inout), dimension(:,:) :: C

      integer :: K
      real(DP) :: eps, normA, normB, normC
      real(DP), dimension(NUMBER_OF_PROCESSORS()) :: start, times

      INTERFACE
      double precision function dmatnrm(A)
         include 'misc.h'
         real(DP), intent(in), dimension(:,:) :: A
      end function dmatnrm
      extrinsic(hpf_local) function SLhpf_walltime()
         include 'misc.h'
         include 'pblas.h'
         real(DP), dimension(NUMBER_OF_PROCESSORS()) :: SLhpf_walltime
!HPF$    DISTRIBUTE(block) :: SLhpf_walltime
      end function SLhpf_walltime
      END INTERFACE

      if ( transA.eq.'n' .or. transA.eq.'N' ) then
         normA = dmatnrm(A)
         k = size(A,2)
         if ( transB.eq.'n' .or. transB.eq.'N' ) then
            normB = dmatnrm(B)
            start = SLhpf_walltime()
            C = beta*C + alpha * matmul(A,B)
            times = SLhpf_walltime() - start
         else
            normB = dmatnrm( transpose(B) )
            start = SLhpf_walltime()
            C = beta*C + alpha * matmul(A,transpose(B))
            times = SLhpf_walltime() - start
         end if
      else
         normA = dmatnrm( transpose(A) )
         k = size(A,1)
         if ( transB.eq.'n' .or. transB.eq.'N' ) then
            normB = dmatnrm(B)
            start = SLhpf_walltime()
            C = beta*C + alpha * matmul(transpose(A),B)
            times = SLhpf_walltime() - start
         else
            start = SLhpf_walltime()
            normB = dmatnrm( transpose(B) )
            C = beta*C + alpha * matmul(transpose(A),transpose(B))
            times = SLhpf_walltime() - start
         end if
      end if

      eps = epsilon(0.0D0)
      C = C - ANS
      normC = dmatnrm(C)

      k = max( K, size(C,1), size(C,2) )
      dgemmcheck = normC / ( normA * normB * eps * K )

      return
      end

