
      program dsyevtst
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by Caroline A. Papadopoulos , University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      implicit none
      include 'misc.h'
      real(DP), allocatable, dimension(:,:) :: A, Z
      real(DP), allocatable, dimension(:) :: W

      integer :: igrid, imat, itest, k, nbyp, nbypa, nfai, nfail, ngrid,&
     &           ninf, ninfo, nmat, nop, npas, npass, nski, nskip,      &
     &           ntest
      integer, pointer, dimension(:) :: IAval, IZval, JAval, JZval,     &
     &                                  M_Aval, M_Zval, N_Aval, N_Zval, &
     &                                  Nval, Pval, Qval, UPLOval,      &
     &                                  csrc_Aval, csrc_Zval, mb_Aval,  &
     &                                  mb_Zval, nb_Aval, nb_Zval,      &
     &                                  rsrc_Aval, rsrc_Zval
      real :: thresh

      INTERFACE
      extrinsic(hpf_local) subroutine SLhpf_exit()
      end subroutine SLhpf_exit

      subroutine dsyevtst2(thresh, N0, P, Q, mb_A, nb_A, mb_Z, nb_Z,    &
     &                     rsrc_A, csrc_A, rsrc_Z, csrc_Z, Nop, UPLOval,&
     &                     Nval, IAval, JAval, IZval, JZval, A, Z, W,   &
     &                     npass, nfail, nskip, ninfo, nbyp)
         include 'misc.h'
         integer, intent(in) :: N0, P, Q, mb_A, nb_A, mb_Z, nb_Z,       &
     &                          rsrc_A, csrc_A, rsrc_Z, csrc_Z, Nop
         integer, intent(in), dimension(:) :: IAval, IZval, JAval,      &
     &                                        JZval, Nval, UPLOval
         integer, intent(out) :: npass, nfail, nskip, ninfo, nbyp
         real, intent(in) :: thresh
         real(DP), dimension(:,:) :: A, Z
         real(DP), dimension(:) :: W
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ TEMPLATE, DIMENSION(N0, N0) :: ATEMP, ZTEMP
!HPF$ DISTRIBUTE ATEMP(cyclic(mb_A), cyclic(nb_A)) ONTO PROC
!HPF$ DISTRIBUTE ZTEMP(cyclic(mb_Z), cyclic(nb_Z)) ONTO PROC
!HPF$ ALIGN A(I,J) WITH ATEMP(rsrc_A*mb_A+I, csrc_A*nb_A+J)
!HPF$ ALIGN Z(I,J) WITH ZTEMP(rsrc_Z*mb_Z+I, csrc_Z*nb_Z+J)
      end subroutine dsyevtst2

      subroutine dsyevinfo(thresh, ngrid, nmat, nop, Pval, Qval, mAval, &
     &                     nAval, mbAval, nbAval, rsrcAval, csrcAval,   &
     &                     mZval, nZval, mbZval, nbZval, rsrcZval,      &
     &                     csrcZval, UPLOval, Nval, IAval, JAval, IZval,&
     &                     JZval)
         real, intent(out) :: thresh
         integer, intent(out) :: ngrid, nmat, nop
         integer, pointer, dimension(:) :: IAval, IZval, JAval, JZval,  &
     &                                     Nval, Pval, Qval, UPLOval,   &
     &                                     csrcAval, csrcZval, mAval,   &
     &                                     mZval, mbAval, mbZval, nAval,&
     &                                     nZval, nbAval, nbZval,       &
     &                                     rsrcAval, rsrcZval
      end subroutine dsyevinfo

      END INTERFACE

      call dsyevinfo(thresh, ngrid, nmat, nop, Pval, Qval, M_Aval,      &
     &               N_Aval, mb_Aval, nb_Aval, rsrc_Aval, csrc_Aval,    &
     &               M_Zval, N_Zval, mb_Zval, nb_Zval, rsrc_Zval,       &
     &               csrc_Zval, UPLOval, Nval, IAval, JAval, IZval,     &
     &               JZval)

      itest = 1
      nfail = 0; npass = 0; nskip = 0; ninfo = 0; ntest = 0; nbypa = 0
!
!     Find upper bound for template size
!
      k = max( maxval(MB_Aval), maxval(NB_Aval), maxval(MB_Zval),       &
     &         maxval(NB_Zval) )
      k = k * max( maxval(rsrc_Aval), maxval(csrc_Aval),                &
     &             maxval(rsrc_Zval), maxval(csrc_Zval) )
      k = k + max( maxval(M_Aval), maxval(N_Aval), maxval(M_Zval),      &
     &             maxval(N_Zval) )
      do igrid = 1, ngrid
         do imat = 1, nmat
            write(*,*) ' '
            write(*,5000)
            write(*,1000) itest
            write(*,2000) Pval(igrid), Qval(igrid)
            write(*,3000) M_Aval(imat), N_Aval(imat), mb_Aval(imat),    &
     &                    nb_Aval(imat), rsrc_Aval(imat),               &
     &                    csrc_Aval(imat)
            write(*,4000) M_Zval(imat), N_Zval(imat), mb_Zval(imat),    &
     &                    nb_Zval(imat), rsrc_Zval(imat),               &
     &                    csrc_Zval(imat)
            write(*,5000)
            allocate( A(M_Aval(imat), N_Aval(imat)) )
            allocate( Z(M_Zval(imat), N_Zval(imat)) )
            allocate( W(M_Aval(imat)) )
            A = -99.9D10
            Z = -99.8D10
            W = -99.7D10
            call dsyevtst2(thresh, k, Pval(igrid), Qval(igrid),         &
     &                     mb_Aval(imat), nb_Aval(imat), mb_Zval(imat), &
     &                     nb_Zval(imat), rsrc_Aval(imat),              &
     &                     csrc_Aval(imat), rsrc_Zval(imat),            &
     &                     csrc_Zval(imat), Nop, UPLOval, Nval, IAval,  &
     &                     JAval, IZval, JZval, A, Z, W, npas, nfai,    &
     &                     nski, ninf, nbyp)
            npass = npass + npas
            nfail = nfail + nfai
            nskip = nskip + nski
            ninfo = ninfo + ninf
            nbypa = nbypa + nbyp
            write(*,5000)
            write(*,6000) itest
            write(*,5000)
            write(*,*) ' '
            deallocate(A)
            deallocate(Z)
            deallocate(W)
            itest = itest + 1
         end do
      end do
      deallocate( Pval, Qval, m_Aval, n_Aval, mb_Aval, nb_Aval,         &
     &            rsrc_Aval, csrc_Aval, m_Zval, n_Zval, mb_Zval,        &
     &            nb_Zval, rsrc_Zval, csrc_Zval, UPLOval, Nval )

      write(*,*) ' '
      write(*,*) ' '
      write(*,*) ' '
      write(*,5000)
      write(*,5000)
      write(*,7000) Nop*(itest-1), npass, nfail, nskip, ninfo, nbypa
      write(*,5000)
      write(*,5000)
      call SLhpf_exit()

 1000 format(x,'Begin test batch #',i6,':')
 2000 format(x,'P =',i4, '; Q =',i4,';')
 3000 format(x,'M_A =',i6,'; N_A =',i6,'; MB_A =',i4,'; NB_A =',i4,     &
     &       '; RSRC_A =',i3,'; CSRC_A =',i3)
 4000 format(x,'M_Z =',i6,'; N_Z =',i6,'; MB_Z =',i4,'; NB_Z =',i4,     &
     &       '; RSRC_Z =',i3,'; CSRC_Z =',i3)
 5000 format(x,'******************************************************' &
     &         '*************************')
 6000 format(x,'Done  test batch #',i6,'.')
 7000 format(x,I5,' TESTS:',I5,' PASSED,',I5,' FAILED,',I5,' SKIPPED,', &
     &       I5,' BAD INFO',I5,' BYPASS')

      stop
      end

      subroutine dsyevtst2(thresh, N0, P, Q, mb_A, nb_A, mb_Z, nb_Z,    &
     &                     rsrc_A, csrc_A, rsrc_Z, csrc_Z,              &
     &                     Nop, UPLOval, Nval, IAval, JAval,            &
     &                     IZval, JZval, A, Z, W, npass, nfail, nskip,  &
     &                     ninfo, nbyp)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by Caroline A. Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      USE HPF_LAPACK
      include 'misc.h'
      character(LEN=1) :: uplo
      integer, intent(in), dimension(:) :: UPLOval
      integer, intent(in) :: N0, P, Q, mb_A, nb_A, mb_Z, nb_Z,          &
     &                       rsrc_A, csrc_A, rsrc_Z, csrc_Z, Nop
      integer, intent(in), dimension(:) :: Nval, IAval, JAval,          &
     &                                     IZval, JZval
      integer, intent(out) :: npass, nfail, nskip, ninfo, nbyp
      real, intent(in) :: thresh
      real(DP), dimension(:,:) :: A, Z
      real(DP), dimension(:) :: W
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ TEMPLATE, DIMENSION(N0, N0) :: ATEMP, ZTEMP
!HPF$ DISTRIBUTE ATEMP(cyclic(mb_A), cyclic(nb_A)) ONTO PROC
!HPF$ DISTRIBUTE ZTEMP(cyclic(mb_Z), cyclic(nb_Z)) ONTO PROC
!HPF$ ALIGN A(I,J) WITH ATEMP(rsrc_A*mb_A+I, csrc_A*nb_A+J)
!HPF$ ALIGN Z(I,J) WITH ZTEMP(rsrc_Z*mb_Z+I, csrc_Z*nb_Z+J)

      character*7 stat
      real(DP), allocatable, dimension(:,:) :: A0
      real(DP), allocatable, dimension(:,:) :: X0
      real(DP) normA, eps, eigres, temp1, temp2
      integer :: i, j, k, ia, ja, iz, jz, info
      integer :: n, AM, AN, ZM, ZN,                                     &
     &           IAbeg, IAend, IAinc, JAbeg, JAend, JAinc,              &
     &           IZbeg, IZend, IZinc, JZbeg, JZend, JZinc
      real(DP), dimension(NUMBER_OF_PROCESSORS()) :: start, times

      INTERFACE
      double precision function deigcheck(A, Z, W)
         include 'misc.h'
         real(DP), dimension(:,:), intent(in) :: A, Z
         real(DP), dimension(:), intent(in) :: W
      end function deigcheck

      extrinsic(hpf_local) function SLhpf_walltime()
         include 'misc.h'
         include 'pblas.h'
         real(DP), dimension(NUMBER_OF_PROCESSORS()) :: SLhpf_walltime
!HPF$    DISTRIBUTE(block) :: SLhpf_walltime
      end function SLhpf_walltime
      END INTERFACE

      print*,'STATUS  UP     N    IA    JA    IZ    JZ  INFO'//         &
     &       '    RESID     WALLTIME'
      print*,'======= == ===== ===== ===== ===== ===== ====='//         &
     &       ' ======== ========'

      npass = 0; nfail = 0; nskip = 0; ninfo = 0; nbyp = 0
      do k = 1, Nop
         if (UPLOval(k) .eq. 1) then
            uplo = 'U'
         else
            uplo = 'L'
         end if
         N = Nval(k)
         IA = IAval(k)
         JA = JAval(k)
         IZ = IZval(k)
         JZ = JZval(k)
         write(*,1000) 'RUNNING', uplo, N, IA, JA, IZ, JZ, 0,           &
     &                 0.0D0, 0.0D0
         AM = N + IA-1
         AN = N + JA-1
         ZM = N + IZ-1
         ZN = N + JZ-1
         if ( (AM.le.size(A,1)) .and. (AN.le.size(A,2)) ) then
            call random_number(A(IA:AM, JA:AN))

!
!           For ease of testing, actually reflect matrix, and force it to
!           be diagonally dominant
!
            forall(i=0:N-1, j=0:N-1, i.lt.j) A(IA+i,JA+j) = A(IA+j,JA+i)
            forall (i=0:N-1) A(IA+i,JA+i) = sum(abs(A(IA:AM,JA+i)))

            if (thresh .ge. 0.0E0) then
               allocate( A0(N, N), X0(N, N) )
               A0(1:N,1:N) = A(IA:AM, JA:AN)
            end if

            start = SLhpf_walltime()
            call la_syev(A(IA:AM, JA:AN),W(IA:AM), Z(IZ:ZM, JZ:ZN),      &
     &                            uplo, info)
            times = SLhpf_walltime() - start

            eigres = -1.0D0
            if (info .eq. 0) then
               if (thresh .ge. 0.0E0) then
                  eigres = deigcheck(A0, Z(IZ:ZM, JZ:ZN), W(IA:AM))
                  if (eigres .gt. thresh) then
                     stat = 'FAILED '
                     nfail = nfail + 1
                  else
                     stat = 'PASSED '
                     npass = npass + 1
                  end if
                  deallocate( A0 )
               else
                  nbyp = nbyp + 1
                  stat = 'BYPASS '
                  eigres = 0.0D0
               end if
            else
               ninfo = ninfo + 1
               stat = 'BADINFO'
               eigres = dble( info )
            end if
         else
            stat = 'SKIPPED'
            nskip = nskip + 1
         end if

         write(*,1000) stat, uplo, N, IA, JA, IZ, JZ, INFO, eigres,     &
     &                  maxval(times)
      end do
      write(*,2000) Nop, npass, nfail, nskip, ninfo, nbyp

 1000 format(x, a7, 2x, a1, 6I6, E9.1, F9.1)
 2000 format(x,I5,' TESTS:',I5,' PASSED,',I5,' FAILED,',I5,' SKIPPED,', &
     &       I5,' BAD INFO', I5, ' BYPASS.')

      return
      end subroutine dsyevtst2


      subroutine dsyevinfo( thresh, ngrid, nmat, nop, Pval, Qval, mAval,&
     &                      nAval, mbAval, nbAval, rsrcAval, csrcAval,  &
     &                      mZval, nZval, mbZval, nbZval, rsrcZval,     &
     &                      csrcZval, UPLOval, Nval, IAval, JAval,      &
     &                      IZval, JZval )
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by Caroline A. Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      include 'misc.h'
      include 'pblas.h'
      real, intent(out) :: thresh
      integer, intent(out) :: ngrid, nmat, nop
      integer, pointer, dimension(:) :: IAval, IZval, JAval, JZval,     &
     &         Nval, Pval, Qval, UPLOval, csrcAval, csrcZval, mAval,    &
     &         mZval, mbAval, mbZval, nAval, nZval, nbAval, nbZval,     &
     &         rsrcAval, rsrcZval
      character(LEN=1), allocatable, dimension(:) :: ctmp
      integer, parameter :: nin=11
      integer :: i

      open(nin, file='syev.dat', STATUS='OLD')

      read(nin,*) ngrid
      allocate( Pval(ngrid), Qval(ngrid) )
      read(nin,*) ( Pval(i), i = 1, ngrid )
      read(nin,*) ( Qval(i), i = 1, ngrid )

      read(nin,*) nmat
      allocate( mAval(nmat), nAval(nmat), mbAval(nmat), nbAval(nmat),   &
     &          rsrcAval(nmat), csrcAval(nmat), mZval(nmat),            &
     &          nZval(nmat), mbZval(nmat), nbZval(nmat), rsrcZval(nmat),&
     &          csrcZval(nmat) )

      read(nin,*) ( mAval(i), i = 1, nmat )
      read(nin,*) ( nAval(i), i = 1, nmat )
      read(nin,*) ( mbAval(i), i = 1, nmat )
      read(nin,*) ( nbAval(i), i = 1, nmat )
      read(nin,*) ( rsrcAval(i), i = 1, nmat )
      read(nin,*) ( csrcAval(i), i = 1, nmat )
      read(nin,*) ( mZval(i), i = 1, nmat )
      read(nin,*) ( nZval(i), i = 1, nmat )
      read(nin,*) ( mbZval(i), i = 1, nmat )
      read(nin,*) ( nbZval(i), i = 1, nmat )
      read(nin,*) ( rsrcZval(i), i = 1, nmat )
      read(nin,*) ( csrcZval(i), i = 1, nmat )

      read(nin,*) nop
      allocate( Nval(nop), IAval(nop), JAval(nop), IZval(nop),          &
     &          JZval(nop), UPLOval(nop) )
!
!     Store character info in an integer array to get around pghpf compiler
!     error with having character arrays have the pointer attribute
!
      allocate( ctmp(nop) )
      read(nin,*) ( ctmp(i), i = 1, nop )
      do i = 1, nop
         if ( (ctmp(i).eq.'U') .or. (ctmp(i).eq.'u') ) then
            UPLOval(i) = 1
         else
            if ( (ctmp(i).ne.'L') .and. (ctmp(i).ne.'l') ) then
               print*,'Unknown UPLO value ''',ctmp(i),                  &
     &                ''' assumed to be L.'
            end if
            UPLOval(i) = 2
         end if
      end do
      deallocate( ctmp )

      read(nin,*) ( Nval(i), i = 1, nop )
      read(nin,*) ( IAval(i), i = 1, nop )
      read(nin,*) ( JAval(i), i = 1, nop )
      read(nin,*) ( IZval(i), i = 1, nop )
      read(nin,*) ( JZval(i), i = 1, nop )
      read(nin,*) thresh

      close(nin)

      return
      end subroutine dsyevinfo


      double precision function deigcheck(A, Z, W)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by Caroline A. Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      include 'misc.h'
      real(DP), dimension(:,:), intent(in) :: A, Z
      real(DP), dimension(:), intent(in) :: W
      integer :: n, i, j
      real(DP), allocatable, dimension(:,:) :: AZ, temp
      real(DP) :: normA, eps, num, den, tempnorm
      real(DP) :: maxnorm, maxnorm2

      INTERFACE
      double precision function dmatnrm(A)
         include 'misc.h'
         real(DP), dimension(:,:), intent(in) :: A
      end function dmatnrm
      END INTERFACE

!
!     Calculate norm of A and machine epsilon
!
      normA = dmatnrm(A)
      eps = epsilon(0.0D0)

      n = size(A, 1)
      allocate( AZ(n, n) , temp(n,n))
!
!     Check:  ||AZ - ZD|| / ( ||A|| * N * eps)
!
      maxnorm = 0.0
      den = normA * eps * n
      AZ = matmul(A, Z)
      do j = 1, n
         temp(1:n,j) = w(j) * Z(1:n,j)
      end do

      temp = AZ - temp
      tempnorm = dmatnrm(temp)
      maxnorm = tempnorm/den

!
!     Check:  ||ZZT - I|| / ( N * eps)
!

      temp = matmul(Z, transpose(Z))
      do i = 1,n
         temp(i,i) = temp(i,i) - 1.0D0
      end do

      tempnorm = dmatnrm(temp)
      maxnorm2 = tempnorm/(n*eps)

      if (maxnorm2 .gt. maxnorm) then
         deigcheck = maxnorm2
      else
         deigcheck = maxnorm
      end if

      deallocate( AZ, temp )

      return
      end

      double precision function dmatnrm(A)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by Caroline A. Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      include 'misc.h'
      real(DP), intent(in), dimension(:,:) :: A
      integer :: i
      real(DP) :: maxnrm, tmp

      maxnrm = 0.0D0
      do i = 1, size(A,1)
         tmp = sum( abs(A(i,:)) )
         if (tmp .gt. maxnrm) maxnrm = tmp
      end do

      dmatnrm = maxnrm

      return
      end

