      program gemm_timer
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      USE HPF_LAPACK
      integer, parameter :: N=1000, NB=50, P=2, Q=2
      integer, parameter :: DP=kind(0.0D0)
      integer :: count0, count, crate
      real(DP), dimension(N,N) :: A, B, C
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ DISTRIBUTE (cyclic(NB), cyclic(NB)) ONTO PROC :: A, B, C

      integer :: I, N0, NN, incN
      real(DP) :: mm_time

      print*,'Enter N0, NN, incN:'
      read(*,*) N0, NN, incN
      print*,' '
      call random_number(A(1:10,1:10))
      call random_number(B(1:10,1:10))
      call random_number(C(1:10,1:10))
      C(1:10,1:10) = matmul( A(1:10,1:10), B(1:10,1:10) )
      call LA_GEMM(A(1:10, 1:10), B(1:10, 1:10), C(1:10, 1:10))
      C = 0.0

      do I = N0, NN, incN
         call random_number(A(1:i,1:i))
         call random_number(B(1:i,1:i))
!
!        Call LA_GEMM
!
         call system_clock(count0, crate)
         call LA_GEMM(A(1:I, 1:I), B(1:I, 1:I), C(1:I, 1:I))
         call system_clock(count)

         mm_time = (1.0D0*(count-count0))/(1.0D0*crate)
         write(*,2000) I, mm_time
!
!        Call MATMUL
!
         call system_clock(count0, crate)
         C(1:i,1:i) = matmul( A(1:i,1:i), B(1:i,1:i) )
         call system_clock(count)

         mm_time = (1.0D0*(count-count0))/(1.0D0*crate)
         write(*,1000) I, mm_time
      end do

 1000 format('N =',I6,'; MATMUL  time (s) =',F15.2);
 2000 format('N =',I6,'; LA_GEMM time (s) =',F15.2);
      stop
      end
