      real function smatnrm(A)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      include 'misc.h'
      real(SP), intent(in), dimension(:,:) :: A
      integer :: i
      real(SP) :: maxnrm, tmp

      maxnrm = 0.0E0
      do i = 1, size(A,1)
         tmp = sum( abs(A(i,:)) )
         if (tmp .gt. maxnrm) maxnrm = tmp
      end do

      smatnrm = maxnrm

      RETURN
      END

      real function smatnrm_v(V)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by Caroline Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      include 'misc.h'
      real(SP), intent(in), dimension(:) :: V
      integer :: i
      real(SP) :: maxnrm, tmp

      maxnrm = 0.0E0
      do i = 1, size(V,1)
         tmp = abs(V(i))
         if (tmp .gt. maxnrm) maxnrm = tmp
      end do

      smatnrm_v = maxnrm

      RETURN
      END

      subroutine gelsinfo( thresh, ngrid, nmat, nop, Pval, Qval, mAval, &
     &                     nAval, mbAval, nbAval, rsrcAval, csrcAval,   &
     &                     mBval, nBval, mbBval, nbBval, rsrcBval,      &
     &                     csrcBval, TRANSval, Mval, Nval, NRHSval,     &
     &                     IAval, JAval, IBval, JBval )
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      real, intent(out) :: thresh
      integer, intent(out) :: ngrid, nmat, nop
      integer, pointer, dimension(:) :: IAval, IBval, JAval, JBval,     &
     &         Mval, NRHSval, Nval, Pval, Qval, TRANSval, csrcAval,     &
     &         csrcBval, mAval, mBval, mbAval, mbBval, nAval, nBval,    &
     &         nbAval, nbBval, rsrcAval, rsrcBval
      character(LEN=1), allocatable, dimension(:) :: ctmp
      integer, parameter :: nin=11
      integer :: i

      open(nin, file='gels.dat', STATUS='OLD')

      read(nin,*) ngrid
      allocate( Pval(ngrid), Qval(ngrid) )
      read(nin,*) ( Pval(i), i = 1, ngrid )
      read(nin,*) ( Qval(i), i = 1, ngrid )

      read(nin,*) nmat
      allocate( mAval(nmat), nAval(nmat), mbAval(nmat), nbAval(nmat),   &
     &          rsrcAval(nmat), csrcAval(nmat), mBval(nmat),            &
     &          nBval(nmat), mbBval(nmat), nbBval(nmat), rsrcBval(nmat),&
     &          csrcBval(nmat) )

      read(nin,*) ( mAval(i), i = 1, nmat )
      read(nin,*) ( nAval(i), i = 1, nmat )
      read(nin,*) ( mbAval(i), i = 1, nmat )
      read(nin,*) ( nbAval(i), i = 1, nmat )
      read(nin,*) ( rsrcAval(i), i = 1, nmat )
      read(nin,*) ( csrcAval(i), i = 1, nmat )
      read(nin,*) ( mBval(i), i = 1, nmat )
      read(nin,*) ( nBval(i), i = 1, nmat )
      read(nin,*) ( mbBval(i), i = 1, nmat )
      read(nin,*) ( nbBval(i), i = 1, nmat )
      read(nin,*) ( rsrcBval(i), i = 1, nmat )
      read(nin,*) ( csrcBval(i), i = 1, nmat )

      read(nin,*) nop
      allocate( Mval(nop), Nval(nop), IAval(nop), JAval(nop),           &
     &          IBval(nop), JBval(nop), TRANSval(nop), NRHSval(nop) )
!
!     Store character info in an integer array to get around pghpf compiler
!     error with having character arrays have the pointer attribute
!
      allocate( ctmp(nop) )
      read(nin,*) ( ctmp(i), i = 1, nop )
      do i = 1, nop
         TRANSval(i) = iachar( ctmp(i) )
      end do

      deallocate( ctmp )
      read(nin,*) ( Mval(i), i = 1, nop )
      read(nin,*) ( Nval(i), i = 1, nop )
      read(nin,*) ( NRHSval(i), i = 1, nop )
      read(nin,*) ( IAval(i), i = 1, nop )
      read(nin,*) ( JAval(i), i = 1, nop )
      read(nin,*) ( IBval(i), i = 1, nop )
      read(nin,*) ( JBval(i), i = 1, nop )
      read(nin,*) thresh

      close(nin)

      return
      end subroutine gelsinfo

      program sgelstst

!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     University of Tennessee, Knoxville
!     Code contributors: R. Clint Whaley
!     Last modified by: C. A. Papadopoulos
!
      include 'misc.h'
      real(SP), allocatable, dimension(:,:) :: A, X, B
      real(SP), allocatable, dimension(:) :: X_V, B_V

      INTERFACE
      extrinsic(hpf_local) subroutine SLhpf_exit()
      end subroutine SLhpf_exit

      subroutine sgelstst2(thresh, N0, P, Q, mb_A, nb_A, mb_B, nb_B,    &
     &                     rsrc_A, csrc_A, rsrc_B, csrc_B, Nop,         &
     &                     TRANSval, Mval, Nval, NRHSval, IAval, JAval, &
     &                     IBval, JBval, A, B, npass, nfail, nskip,     &
     &                     ninfo, nbyp)
         include 'misc.h'
         integer, intent(in) :: N0, P, Q, mb_A, nb_A, mb_B, nb_B,       &
     &                          rsrc_A, csrc_A, rsrc_B, csrc_B, Nop
         integer, intent(in), dimension(:) :: IAval, IBval, JAval,      &
     &                                        JBval, Mval, NRHSval,     &
     &                                        Nval, TRANSval
         integer, intent(out) :: npass, nfail, nskip, ninfo, nbyp
         real, intent(in) :: thresh
         real(SP), dimension(:,:) :: A, B
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ TEMPLATE, DIMENSION(N0, N0) :: ATEMP, BTEMP
!HPF$ DISTRIBUTE ATEMP(cyclic(mb_A), cyclic(nb_A)) ONTO PROC
!HPF$ DISTRIBUTE BTEMP(cyclic(mb_B), cyclic(nb_B)) ONTO PROC
!HPF$ ALIGN A(I,J) WITH ATEMP(rsrc_A*mb_A+I, csrc_A*nb_A+J)
!HPF$ ALIGN B(I,J) WITH BTEMP(rsrc_B*mb_B+I, csrc_B*nb_B+J)
      end subroutine sgelstst2


      subroutine sgelstst2_v(thresh, N0, P, Q, mb_A, nb_A, mb_B, rsrc_A,&
     &                       csrc_A, rsrc_B, csrc_B, Nop, TRANSval,     &
     &                       Mval, Nval, IAval, JAval, IBval, A, B_V,   &
     &                       npass, nfail, nskip, ninfo, nbyp)
         include 'misc.h'
         integer, intent(in) :: N0, P, Q, mb_A, nb_A, mb_B,             &
     &                          rsrc_A, csrc_A, rsrc_B, csrc_B, Nop
         integer, intent(in), dimension(:) :: IAval, IBval, JAval, Mval,&
     &                                        Nval, TRANSval
         integer, intent(out) :: npass, nfail, nskip, ninfo, nbyp
         real, intent(in) :: thresh
         real(SP), dimension(:,:) :: A
         real(SP), dimension(:) :: B_V
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ TEMPLATE, DIMENSION(N0, N0) :: ATEMP
!HPF$ DISTRIBUTE ATEMP(cyclic(mb_A), cyclic(nb_A)) ONTO PROC
!HPF$ ALIGN A(I,J) WITH ATEMP(rsrc_A*mb_A+I, csrc_A*nb_A+J)
!HPF$ ALIGN B_V(I) WITH ATEMP(rsrc_B*mb_B+I,1)
      end subroutine sgelstst2_v


      subroutine gelsinfo(thresh, ngrid, nmat, nop, Pval, Qval, mAval,  &
     &                    nAval, mbAval, nbAval, rsrcAval, csrcAval,    &
     &                    mBval, nBval, mbBval, nbBval, rsrcBval,       &
     &                    csrcBval, TRANSval, Mval, Nval, NRHSval,      &
     &                    IAval, JAval, IBval, JBval)
         real, intent(out) :: thresh
         integer, intent(out) :: ngrid, nmat, nop
         integer, pointer, dimension(:) :: IAval, IBval, JAval, JBval,  &
     &                                     Mval, NRHSval, Nval, Pval,   &
     &                                     Qval, TRANSval, csrcAval,    &
     &                                     csrcBval, mAval, mBval,      &
     &                                     mbAval, mbBval, nAval, nBval,&
     &                                     nbAval, nbBval, rsrcAval,    &
     &                                     rsrcBval
      end subroutine gelsinfo
      END INTERFACE

      character(LEN=1) :: ctmp
      integer :: igrid, imat, itest, k, nbyp, nbypa, nfai, nfail, ngrid,&
     &           ninf, ninfo, nmat, nop, npas, npass, nski, nskip,      &
     &           ntest
      integer, pointer, dimension(:) :: IAval, IBval, JAval, JBval,     &
     &                                  M_Aval, M_Bval, Mval, NRHSval,  &
     &                                  N_Aval, N_Bval, Nval, Pval,     &
     &                                  Qval, TRANSval, csrc_Aval,      &
     &                                  csrc_Bval, mb_Aval, mb_Bval,    &
     &                                  nb_Aval, nb_Bval, rsrc_Aval,    &
     &                                  rsrc_Bval
      real :: thresh

      call gelsinfo(thresh, ngrid, nmat, nop, Pval, Qval, M_Aval,       &
     &              N_Aval, mb_Aval, nb_Aval, rsrc_Aval, csrc_Aval,     &
     &              M_Bval, N_Bval, mb_Bval, nb_Bval, rsrc_Bval,        &
     &              csrc_Bval, TRANSval, Mval, Nval, NRHSval, IAval,    &
     &              JAval, IBval, JBval)
      itest = 1
      nfail = 0; npass = 0; nskip = 0; ninfo = 0; ntest = 0; nbypa = 0
!
!     Find upper bound for template size
!
      k = max( maxval(MB_Aval), maxval(NB_Aval), maxval(MB_Bval),       &
     &         maxval(NB_Bval) )
      k = k * max( maxval(rsrc_Aval), maxval(csrc_Aval),                &
     &             maxval(rsrc_Bval), maxval(csrc_Bval) )
      k = k + max( maxval(M_Aval), maxval(N_Aval), maxval(M_Bval),      &
     &             maxval(N_Bval) )
      do igrid = 1, ngrid
         do imat = 1, nmat
            write(*,*) ' '
            write(*,5000)
            write(*,1000) itest
            write(*,2000) Pval(igrid), Qval(igrid)
            write(*,3000) M_Aval(imat), N_Aval(imat), mb_Aval(imat),    &
     &                    nb_Aval(imat), rsrc_Aval(imat),               &
     &                    csrc_Aval(imat)
            write(*,4000) M_Bval(imat), N_Bval(imat), mb_Bval(imat),    &
     &                    nb_Bval(imat), rsrc_Bval(imat),               &
     &                    csrc_Bval(imat)
            write(*,5000)
            allocate( A(M_Aval(imat), N_Aval(imat)) )
            allocate( B(M_Bval(imat), N_Bval(imat)) )
            allocate( B_V(M_Bval(imat)) )
            A = -99.9E10
            B = -99.8E10
            B_V = -99.8E10
            call sgelstst2(thresh, k, Pval(igrid), Qval(igrid),         &
     &                     mb_Aval(imat), nb_Aval(imat), mb_Bval(imat), &
     &                     nb_Bval(imat), rsrc_Aval(imat),              &
     &                     csrc_Aval(imat), rsrc_Bval(imat),            &
     &                     csrc_Bval(imat), Nop, TRANSval, Mval, Nval,  &
     &                     NRHSval, IAval, JAval, IBval, JBval, A, B,   &
     &                     npas, nfai, nski, ninf, nbyp)
            npass = npass + npas
            nfail = nfail + nfai
            nskip = nskip + nski
            ninfo = ninfo + ninf
            nbypa = nbypa + nbyp
            write(*,5000)
            write(*,6000) itest
            write(*,5000)
            write(*,*) ' '
            call sgelstst2_v(thresh, k, Pval(igrid), Qval(igrid),       &
     &                       mb_Aval(imat), nb_Aval(imat),              &
     &                       mb_Bval(imat), rsrc_Aval(imat),            &
     &                       csrc_Aval(imat), rsrc_Bval(imat),          &
     &                       csrc_Bval(imat), Nop, TRANSval, Mval, Nval,&
     &                       IAval, JAval, IBval, A, B_V, npas, nfai,   &
     &                       nski, ninf, nbyp)
            npass = npass + npas
            nfail = nfail + nfai
            nskip = nskip + nski
            ninfo = ninfo + ninf
            nbypa = nbypa + nbyp
            write(*,5000)
            write(*,6000) itest
            write(*,5000)
            write(*,*) ' '
            deallocate(B_V)
            deallocate(A)
            deallocate(B)
            itest = itest + 1
         end do
      end do
      deallocate( Pval, Qval, m_Aval, n_Aval, mb_Aval, nb_Aval,         &
     &            rsrc_Aval, csrc_Aval, m_Bval, n_Bval, mb_Bval,        &
     &            nb_Bval, rsrc_Bval, csrc_Bval, TRANSval, NRHSval,     &
     &            Mval, Nval )

      write(*,*) ' '
      write(*,*) ' '
      write(*,*) ' '
      write(*,5000)
      write(*,5000)
      write(*,7000) 2*Nop*(itest-1), npass, nfail, nskip, ninfo, nbypa
      write(*,5000)
      write(*,5000)
      call SLhpf_exit()

 1000 format(x,'Begin test batch #',i6,':')
 2000 format(x,'P =',i4, '; Q =',i4,';')
 3000 format(x,'M_A =',i6,'; N_A =',i6,'; MB_A =',i4,'; NB_A =',i4,     &
     &       '; RSRC_A =',i3,'; CSRC_A =',i3)
 4000 format(x,'M_B =',i6,'; N_B =',i6,'; MB_B =',i4,'; NB_B =',i4,     &
     &       '; RSRC_B =',i3,'; CSRC_B =',i3)
 5000 format(x,'******************************************************' &
     &         '*************************')
 6000 format(x,'Done  test batch #',i6,'.')
 7000 format(x,I5,' TESTS:',I5,' PASSED,',I5,' FAILED,',I5,' SKIPPED,', &
     &       I5,' BAD INFO',I5,' BYPASS')

      stop
      end

      subroutine sgelstst2(thresh, N0, P, Q, mb_A, nb_A, mb_B, nb_B,    &
     &                     rsrc_A, csrc_A, rsrc_B, csrc_B,              &
     &                     Nop, TRANSval, Mval, Nval, NRHSval, IAval,   &
     &                     JAval, IBval, JBval, A, B, npass, nfail,     &
     &                     nskip, ninfo, nbyp)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      USE HPF_LAPACK
      include 'misc.h'
      character(LEN=1) :: trans
      integer, intent(in), dimension(:) :: TRANSval
      integer, intent(in) :: N0, P, Q, mb_A, nb_A, mb_B, nb_B,          &
     &                       rsrc_A, csrc_A, rsrc_B, csrc_B, Nop
      integer, intent(in), dimension(:) :: Mval, Nval, NRHSval, IAval,  &
     &                                     JAval, IBval, JBval
      integer, intent(out) :: npass, nfail, nskip, ninfo, nbyp
      real, intent(in) :: thresh
      real(SP), dimension(:,:) :: A, B
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ TEMPLATE, DIMENSION(N0, N0) :: ATEMP, BTEMP
!HPF$ DISTRIBUTE ATEMP(cyclic(mb_A), cyclic(nb_A)) ONTO PROC
!HPF$ DISTRIBUTE BTEMP(cyclic(mb_B), cyclic(nb_B)) ONTO PROC
!HPF$ ALIGN A(I,J) WITH ATEMP(rsrc_A*mb_A+I, csrc_A*nb_A+J)
!HPF$ ALIGN B(I,J) WITH BTEMP(rsrc_B*mb_B+I, csrc_B*nb_B+J)

      character*7 stat
      real(SP), allocatable, dimension(:,:) :: A0, B0, X
      real(SP) normA, normX, eps, sres
      integer :: i, ii, j, jj, k, ia, ja, ib, jb, info
      integer :: M, N, AM, AN, BM, BM2, BN, XM, XN, NRHS,               &
     &           IAbeg, IAend, IAinc, JAbeg, JAend, JAinc,              &
     &           IBbeg, IBend, IBinc, JBbeg, JBend, JBinc
      real(DP), dimension(NUMBER_OF_PROCESSORS()) :: start, times
      intrinsic achar

      INTERFACE

      real function slsqrt16(A, x, b, trans)
      include 'misc.h'
      real(SP), dimension(:,:), intent(in) :: A, x, b
      character(LEN=1), intent(in) :: trans
      end function slsqrt16

      extrinsic(hpf_local) function SLhpf_walltime()
         include 'misc.h'
         include 'pblas.h'
         real(DP), dimension(NUMBER_OF_PROCESSORS()) :: SLhpf_walltime
!HPF$    DISTRIBUTE(block) :: SLhpf_walltime
      end function SLhpf_walltime

      END INTERFACE

      print*,'STATUS  TRANS   M     N    NRHS  IA   JA   IB   JB  '//   &
     &       '  INFO   SOLVE   WALLTIME'
      print*,'======= ===== ===== ===== ===== ==== ==== ==== ==== '//   &
     &       '  ====  =======  ========'

      npass = 0; nfail = 0; nskip = 0; ninfo = 0; nbyp = 0
      do k = 1, Nop
         trans = achar( TRANSval(k) )
         M = Mval(k)
         N = Nval(k)
         NRHS = NRHSval(k)
         IA = IAval(k)
         JA = JAval(k)
         IB = IBval(k)
         JB = JBval(k)
         AM = M + IA-1
         AN = N + JA-1
         if ( trans.eq.'N' .or. trans.eq.'n' ) then
            BM = M + IB-1
            XM = N + IB-1
            allocate( X(N, NRHS) )
            if (thresh .ge. 0.0E0) allocate( B0(M, NRHS) )
         else
            BM = N + IB-1
            XM = M + IB-1
            allocate( X(M, NRHS) )
            if (thresh .ge. 0.0E0) allocate( B0(N, NRHS) )
         end if
         BN = NRHS + JB-1
         BM2 = max(M,N) + IB-1
         write(*,1000) 'RUNNING', trans, M, N, NRHS, IA, JA, IB, JB, 0, &
     &                 0.0E0, 0.0E0

         if ( (AM.le.size(A,1) .and. AN.le.size(A,2)) .AND.             &
     &        (BM2.le.size(B,1) .and. BN.le.size(B,2)) ) then
            call random_number(A(IA:AM, JA:AN))
            call random_number(X)

            do jj = 1, nrhs
               normX = sqrt( sum( X(:,jj)*X(:,jj) ) )
               X(:,jj) = X(:,jj)/normX
            end do

            B(IB:BM, JB:BN) = matmul(A(IA:AM, JA:AN),X)
            deallocate( X )
            if (thresh .ge. 0.0E0) then
               B0 = B(IB:BM, JB:BN)
               allocate( A0(M, N) )
               A0 = A(IA:AM, JA:AN)
            end if

            start = SLhpf_walltime()
            call la_gels(A(IA:AM, JA:AN), B(IB:max(XM, BM), JB:BN),     &
     &                   trans, info)
            times = SLhpf_walltime() - start

            sres = -1.0E0
            if (info .eq. 0) then
               if (thresh .ge. 0.0E0) then
                  sres = slsqrt16( A0, B(IB:XM, JB:BN), B0, trans)
                  if (sres .gt. thresh) then
                     stat = 'FAILED '
                     nfail = nfail + 1
                  else
                     stat = 'PASSED '
                     npass = npass + 1
                  end if
                  deallocate( A0, B0 )
               else
                  nbyp = nbyp + 1
                  stat = 'BYPASS '
                  sres = 0.0E0
               end if
            else
               ninfo = ninfo + 1
               stat = 'BADINFO'
               sres = dble( info )
            end if
         else
            stat = 'SKIPPED'
            nskip = nskip + 1
         end if
         write(*,1000) stat, trans, M, N, NRHS, IA, JA, IB, JB, INFO,   &
     &                 sres, maxval(times)
      end do
      write(*,2000) Nop, npass, nfail, nskip, ninfo, nbyp

 1000 format(x, a7, 2x, a1, 8I6, E9.1, F9.1)
 2000 format(x,I5,' TESTS:',I5,' PASSED,',I5,' FAILED,',I5,' SKIPPED,', &
     &       I5,' BAD INFO,',I5,' BYPASS.')

      RETURN
      END


      subroutine sgelstst2_v(thresh, N0, P, Q, mb_A, nb_A, mb_B,          &
     &                     rsrc_A, csrc_A, rsrc_B, csrc_B,              &
     &                     Nop, TRANSval, Mval, Nval, IAval,            &
     &                     JAval, IBval, A, B_V, npass, nfail,          &
     &                     nskip, ninfo, nbyp)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by C. A. Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      USE HPF_LAPACK
      include 'misc.h'
      character(LEN=1) :: trans
      integer, intent(in), dimension(:) :: TRANSval
      integer, intent(in) :: N0, P, Q, mb_A, nb_A, mb_B,                &
     &                       rsrc_A, csrc_A, rsrc_B, csrc_B, Nop
      integer, intent(in), dimension(:) :: Mval, Nval, IAval,           &
     &                                     JAval, IBval
      integer, intent(out) :: npass, nfail, nskip, ninfo, nbyp
      real, intent(in) :: thresh
      real(SP), dimension(:,:) :: A
      real(SP), dimension(:) :: B_V
!HPF$ PROCESSORS PROC(P,Q)
!HPF$ TEMPLATE, DIMENSION(N0, N0) :: ATEMP, BTEMP
!HPF$ DISTRIBUTE ATEMP(cyclic(mb_A), cyclic(nb_A)) ONTO PROC
!HPF$ ALIGN A(I,J) WITH ATEMP(rsrc_A*mb_A+I, csrc_A*nb_A+J)
!HPF$ ALIGN B_V(I) WITH ATEMP(rsrc_B*mb_B+I, 1)

      character*7 stat
      real(SP), allocatable, dimension(:,:) :: A0
      real(SP), allocatable, dimension(:) :: B0_V, X_V
      real(SP) normA, normX, eps, sres
      integer :: i, ii, j, jj, k, ia, ja, ib, jb, info
      integer :: M, N, AM, AN, BM, BM2, XM, XN,                         &
     &           IAbeg, IAend, IAinc, JAbeg, JAend, JAinc,              &
     &           IBbeg, IBend, IBinc
      real(DP), dimension(NUMBER_OF_PROCESSORS()) :: start, times
      intrinsic achar

      INTERFACE

      real function slsqrt16_v(A, x_v, b_v, trans)
      include 'misc.h'
      real(SP), dimension(:,:), intent(in) :: A
      real(SP), dimension(:), intent(in) :: x_v, b_v
      character(LEN=1), intent(in) :: trans
      end function slsqrt16_v

      extrinsic(hpf_local) function SLhpf_walltime()
         include 'misc.h'
         include 'pblas.h'
         real(DP), dimension(NUMBER_OF_PROCESSORS()) :: SLhpf_walltime
!HPF$    DISTRIBUTE(block) :: SLhpf_walltime
      end function SLhpf_walltime

      END INTERFACE

      print*,'STATUS  TRANS   M     N    IA    JA   IB  '//             &
     &       '  INFO   SOLVE   WALLTIME'
      print*,'======= ===== ===== ===== ===== ==== ==== '//             &
     &       '  ====  =======  ========'

      npass = 0; nfail = 0; nskip = 0; ninfo = 0; nbyp = 0
      do k = 1, Nop
         trans = achar( TRANSval(k) )
         M = Mval(k)
         N = Nval(k)
         IA = IAval(k)
         JA = JAval(k)
         IB = IBval(k)
         AM = M + IA-1
         AN = N + JA-1
         if ( trans.eq.'N' .or. trans.eq.'n' ) then
            BM = M + IB-1
            XM = N + IB-1
            allocate( X_V(N) )
            if (thresh .ge. 0.0E0) allocate( B0_V(M) )
         else
            BM = N + IB-1
            XM = M + IB-1
            allocate( X_V(M) )
            if (thresh .ge. 0.0E0) allocate( B0_V(N) )
         end if
         BM2 = max(M,N) + IB-1
         write(*,1000) 'RUNNING', trans, M, N, IA, JA, IB, 0,           &
     &                 0.0E0, 0.0E0

         if ( (AM.le.size(A,1) .and. AN.le.size(A,2)) .AND.             &
     &        (BM2.le.size(B_V,1))  ) then
            call random_number(A(IA:AM, JA:AN))
            call random_number(X_V)

            normX = sqrt( sum( X_V(:)*X_V(:) ) )
               X_V(:) = X_V(:)/normX
!
! note since for pghpf matmul does not work on vectors use a double do loop
!            B_V(IB:BM) = matmul(A(IA:AM, JA:AN),X_V)
             B_V(IB:BM) = 0.0
             do i = 0,AM - IA
                do j = 0, AN - JA
                   B_V(IB + i) = B_V(IB + i) + A(IA + i,JA + j)*X_V(j+1)
                end do
             end do

            deallocate( X_V )
            if (thresh .ge. 0.0E0) then
               B0_V = B_V(IB:BM)
               allocate( A0(M, N) )
               A0 = A(IA:AM, JA:AN)
            end if

            start = SLhpf_walltime()
            call la_gels(A(IA:AM, JA:AN), B_V(IB:max(XM, BM)),          &
     &                   trans, info)
            times = SLhpf_walltime() - start

            sres = -1.0E0
            if (info .eq. 0) then
               if (thresh .ge. 0.0E0) then
                  sres = slsqrt16_V( A0, B_V(IB:XM), B0_V, trans)
                  if (sres .gt. thresh) then
                     stat = 'FAILED '
                     nfail = nfail + 1
                  else
                     stat = 'PASSED '
                     npass = npass + 1
                  end if
                  deallocate( A0, B0_V )
               else
                  nbyp = nbyp + 1
                  stat = 'BYPASS '
                  sres = 0.0E0
               end if
            else
               ninfo = ninfo + 1
               stat = 'BADINFO'
               sres = dble( info )
            end if
         else
            stat = 'SKIPPED'
            nskip = nskip + 1
         end if
         write(*,1000) stat, trans, M, N, IA, JA, IB, INFO,             &
     &                 sres, maxval(times)
      end do
      write(*,2000) Nop, npass, nfail, nskip, ninfo, nbyp

 1000 format(x, a7, 2x, a1, 6I6, E9.1, F9.1)
 2000 format(x,I5,' TESTS:',I5,' PASSED,',I5,' FAILED,',I5,' SKIPPED,', &
     &       I5,' BAD INFO,',I5,' BYPASS.')

      RETURN
      END


      real function slsqrt16(A, x, b, trans)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      include 'misc.h'
      real(SP), dimension(:,:), intent(in) :: A, x, b
      character(len=1), intent(in) :: trans
      integer :: n, nn, nrhs, i, j
      real(SP), allocatable, dimension(:,:) :: b_Ax
      real(SP), allocatable, dimension(:) :: work(:), xwork(:)
      real(SP) :: normA, eps, num, den, nrm, maxnrm
      INTERFACE
      real function smatnrm(A)
         include 'misc.h'
         real(SP), intent(in), dimension(:,:) :: A
      end function smatnrm
      END INTERFACE

      n = size(A, 1)
      nn = size(x, 1)
      nrhs = size(x, 2)
      allocate( b_Ax(n, nrhs) )
      allocate( work(n) )
      allocate( xwork(nn) )
!
!     Calculate norm of A and machine epsilon
!
      normA = smatnrm(A)
      eps = epsilon(0.0E0)
!
!     Computes || B - op(A)*X ||/(||A||*||x||*max(n,nn)*eps)
!
      maxnrm = 0.0
      den = normA * max(n,nn) * eps
      if (trans.eq.'N' .or. trans.eq.'n') then
         b_Ax = b - matmul(A, x)
      else if ( trans.eq.'T' .or. trans.eq.'t') then
         b_Ax = b - matmul(transpose(A),x)
      end if
      do i = 1, nrhs
         work(:) = abs( b_Ax(:,i) )
         num = maxval( work(:) )
         xwork(:) = abs( x(:,i) )
         nrm = num / ( den * maxval( xwork(:) ) )
         if (nrm .gt. maxnrm) maxnrm = nrm
      end do


      slsqrt16 = maxnrm

      deallocate( b_Ax )
      deallocate( xwork )
      deallocate( work )

      return
      end



      real function slsqrt16_v(A, x_V, b_V, trans)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     Written by C. A. Papadopoulos, University of Tennessee, Knoxville
!     Adapted from SLhpf routines written by R. Clint Whaley,
!     University of Tennessee, Knoxville
!     September 1, 1998
!
      include 'misc.h'
      real(SP), dimension(:,:), intent(in) :: A
      real(SP), dimension(:), intent(in) :: x_v, b_v
      character(len=1), intent(in) :: trans
      integer :: n, nn, nrhs, i, j
      real(SP), allocatable, dimension(:) :: b_Ax
      real(SP) :: work, xwork
      real(SP) :: normA, eps, num, den, nrm, maxnrm
      INTERFACE
      real function smatnrm(A)
         include 'misc.h'
         real(SP), intent(in), dimension(:,:) :: A
      end function smatnrm
      END INTERFACE

      n = size(A, 1)
      nn = size(x_v, 1)
      allocate( b_Ax(n) )
!
!     Calculate norm of A and machine epsilon
!
      normA = smatnrm(A)
      eps = epsilon(0.0E0)
!
!     Computes || B - op(A)*X ||/(||A||*||x||*max(n,nn)*eps)
!
      maxnrm = 0.0
      den = normA * max(n,nn) * eps
      if (trans.eq.'N' .or. trans.eq.'n') then
!
! note since pghpf matmul does not work on vectors use a double do loop
!         b_Ax = b_v - matmul(A, x_v)
        b_Ax = 0.0
        do i=1,n
           do j=1,n
              b_Ax(i) = b_Ax(i) + A(i,j)*x_v(j)
           end do
        end do
        b_Ax =  b_v - b_Ax

      else if ( trans.eq.'T' .or. trans.eq.'t') then

!
! note since pghpf matmul does not work on vectors use a double do loop
!       b_Ax = b_v - matmul(transpose(A), x_v)
        b_Ax = 0.0
        do i=1,n
           do j=1,n
              b_Ax(i) = b_Ax(i) + A(j,i)*x_v(j)
           end do
        end do
        b_Ax =  b_v - b_Ax
      end if
      work = maxval(abs( b_Ax))
      num =  work
      xwork = maxval(abs(x_v) )
      nrm = num / ( den *  xwork )
      if (nrm .gt. maxnrm) maxnrm = nrm

      slsqrt16_v = maxnrm

      deallocate( b_Ax )

      return
      end

